/* defaults.c
 * 
 * Kevin P. Smith  6/11/89
 */
#include "copyright2.h"
#include <stdio.h>

#include "defs.h"		/* for defaultShip() 11/15/91 TC */
#include "struct.h"		/* for defaultShip() 11/15/91 TC */

struct stringlist {
    char *string;
    char *value;
    struct stringlist *next;
};

struct stringlist *defaults=NULL;

char *getenv();
char *strdup();

initDefaults(deffile)
char *deffile;		/* As opposed to defile? */
{
    FILE *fp;
    char file[100];
    char *home;
    char *v;
    struct stringlist *new;

    if (!deffile) {
	deffile=file;
	home=getenv("HOME");
	if (home) {
	    sprintf(file, "%s/.xtrekrc", home);
	} else {
	    strcpy(file, ".xtrekrc");
	}
    }
    fp=fopen(deffile, "r");
    if (!fp) return;
    while (fgets(file, 99, fp)) {
	if (*file=='#') continue;
	if (*file!=0) 
	    file[strlen(file)-1]=0;
	v=file;
	while (*v!=':' && *v!=0) {
	    v++;
	}
	if (*v==0) continue;
	*v=0;
	v++;
	while (*v==' ' || *v=='\t') {
	    v++;
	}
	if (*v!=0) {
	    new=(struct stringlist *) malloc(sizeof(struct stringlist));
	    new->next=defaults;
	    new->string=strdup(file);
	    new->value=strdup(v);
	    defaults=new;
	}
    }
    fclose(fp);
}

char *strdup(str)
char *str;
{
    char *s;

    s=(char *) malloc(strlen(str)+1);
    strcpy(s,str);
    return(s);
}

char *getdefault(str)
char *str;
{
    struct stringlist *sl;

    sl=defaults;
    while (sl!=NULL) {
	if (strcmpi(sl->string, str)==0) {
	    return(sl->value);
	}
	sl=sl->next;
    }
    return(NULL);
}

strcmpi(str1, str2) 
char *str1, *str2;
{
    for(;;) {
	if (*str1<='z' && *str1>='a') *str1+='A'-'a';
	if (*str2<='z' && *str2>='a') *str2+='A'-'a';
	if (*str1 != *str2) return(*str2 - *str1);
	if (*str1==0 || *str2==0) return(0);
	str1++;
	str2++;
    }
}

booleanDefault(def, preferred)
char *def;
int preferred;
{
    char *str;

    str=getdefault(def);
    if (str==NULL) return(preferred);
    if (strcmpi(str,"on")==0) {
	return(1);
    } else {
	return(0);
    }
}

numericDefault(def, preferred, min, max) /* 7/27/91 TC */
char *def;
int preferred;
int min;
int max;
{
    char *str;
    int i;

    str=getdefault(def);
    if (str==NULL) return(preferred);
    if ((i = atoi(str)) != 0) {	/* assume non-zero */
	if ((i >= min) && (i <= max))
	    return i;
    }
    return preferred;
}

/* default ship code, courtesy of Robert Blackburn <blackburn@Virginia.EDU>.
   used by main(), modified to accept 2 letter initials 11/15/91 TC */

int defaultShip(preferred)
int preferred;
{
    char *type;
    
    type = getdefault("defaultship");
    if (type == NULL) return preferred;
    if ((strcmpi(type,"scout")==0)            || (strcmpi(type,"SC")==0))
	return SCOUT;
    else if ((strcmpi(type,"destroyer")==0)   || (strcmpi(type,"DD")==0))
	return DESTROYER;
     else if ((strcmpi(type,"cruiser")==0)    || (strcmpi(type,"CA")==0))
	return CRUISER;
     else if ((strcmpi(type,"battleship")==0) || (strcmpi(type,"BB")==0))
	return BATTLESHIP;
     else if ((strcmpi(type,"assault")==0)    || (strcmpi(type,"AS")==0))
       return ASSAULT;
    else if ((strcmpi(type,"starbase")==0)    || (strcmpi(type,"SB")==0))
       return STARBASE;
    else 
       return preferred;
}
