/* 
 * getname.c
 *
 * Kevin P. Smith 09/28/88
 *
 */
#include "copyright2.h"

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <errno.h>
#include <pwd.h>
#include <string.h>
#include <ctype.h>
#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"
long time();

static char tempname[16];
static char password1[16];
static char password2[16];
static int state;
static struct passwd *passwd;
#define ST_GETNAME 0
#define ST_GETPASS 1
#define ST_MAKEPASS1 2
#define ST_MAKEPASS2 3
#define ST_DONE 4

getname(defname)
char *defname;
/* Let person identify themselves from w */
{
    W_Event event;
    char ch;
    int secondsLeft=99;
    char tempstr[40];
    long lasttime;
    int j;

    passwd=getpwuid(getuid());
    bzero(mystats, sizeof(struct stats));  
    mystats->st_tticks=1;
    for (j=0; j<95; j++) {
	mystats->st_keymap[j]=j+32;
    }
    mystats->st_keymap[95]=0;
    mystats->st_flags = ST_INITIAL;
    lasttime = time(NULL);
    tempname[0]='\0';
    password1[0]='\0';
    password2[0]='\0';
    state=ST_GETNAME;
    displayStartup(defname);
    for (;;) {
	if (isServerDead()) {
	    printf("Ack!  We've been ghostbusted!\n");
	    exit(0);
	}
	if (lasttime != time(NULL)) {
	    lasttime++;
	    secondsLeft--;
	    sprintf(tempstr, "Seconds to go: %d ", secondsLeft);
	    W_WriteText(w, 150, 400, textColor, tempstr, strlen(tempstr),
		W_BoldFont);
	    if (secondsLeft==0) {
		me->p_status = PFREE;
		printf("Auto-Quit\n");
		exit(0);
	    }
	}
	if (state==ST_DONE) {
	    W_ClearWindow(w);
	    return;
	}
	readFromServer();	/* Just in case it wants to say something */
	if (!W_EventsPending()) continue;
	W_NextEvent(&event);
	if (event.Window != w) continue;
	switch ((int) event.type) {
	case W_EV_EXPOSE:
	    displayStartup(defname);
	    break;
	case W_EV_KEY:
	    ch = event.key;
	    if (ch==10) ch=13;
	    if (ch==4 && state==ST_GETNAME && *tempname=='\0') exit(0);
	    if (ch<32 && ch!=21 && ch!=13 && ch!=8) break;
	    switch(state) {
	    case ST_GETNAME:
		if (ch == 13) {
		    if (*tempname == '\0') {
			strcpy(tempname, defname);
		    }
		    loaddude();
		    displayStartup(defname);
		} else {
		    adjustString(ch, tempname, defname);
		}
		break;
	    case ST_GETPASS:
		if (ch == 13) {
		    checkpassword();
		    displayStartup(defname);
		} else {
		    adjustString(ch, password1, defname);
		}
		break;
	    case ST_MAKEPASS1:
		if (ch == 13) {
		    state=ST_MAKEPASS2;
		    displayStartup(defname);
		} else {
		    adjustString(ch, password1, defname);
		}
		break;
	    case ST_MAKEPASS2:
		if (ch == 13) {
		    makeNewGuy();
		    displayStartup(defname);
		} else {
		    adjustString(ch, password2, defname);
		}
		break;
	    }
	}
    }
}

loaddude()
/* Query dude.
 */
{
    if (strcmp(tempname, "Guest")==0 || strcmp(tempname, "guest")==0) {
	loginAccept= -1;
	sendLoginReq(tempname, "", passwd->pw_name, 0);
	state = ST_DONE;
	me->p_pos = -1;
	me->p_stats.st_tticks = 1;	/* prevent overflow */
	strcpy(me->p_name, tempname);
	while (loginAccept== -1) {
	    socketPause();
	    readFromServer();
	    if (isServerDead()) {
		printf("Server is dead!\n");
		exit(0);
	    }
	}
	if (loginAccept==0) {
	    printf("Hmmm... The SOB server won't let me log in as guest!\n");
	    exit(0);
	}
	return;
    }
    /* Ask about the user */
    loginAccept= -1;
    sendLoginReq(tempname, "", passwd->pw_name, 1);
    while (loginAccept== -1) {
	socketPause();
	readFromServer();
	if (isServerDead()) {
	    printf("Server is dead!\n");
	    exit(0);
	}
    }
    *password1= *password2= 0;
    if (loginAccept==0) {
	state = ST_MAKEPASS1;
    } else {
	state = ST_GETPASS;
    }
}

checkpassword()
/* Check dude's password.
 * If he is ok, move to state ST_DONE.
 */
{
    char *s;

    sendLoginReq(tempname, password1, passwd->pw_name, 0);
    loginAccept= -1;
    while (loginAccept== -1) {
	socketPause();
	readFromServer();
	if (isServerDead()) {
	    printf("Server is dead!\n");
	    exit(0);
	}
    }
    if (loginAccept==0) {
	s = "Bad password!";
	W_WriteText(w, 100, 100, textColor, s, strlen(s), W_BoldFont);
	(void) W_EventsPending();
	sleep(3);
	W_ClearWindow(w);
	*tempname=0;
	state=ST_GETNAME;
	return;
    }
    strcpy(me->p_name, tempname);
    showShields = (me->p_stats.st_flags / ST_SHOWSHIELDS) & 1; 
    mapmode = (me->p_stats.st_flags / ST_MAPMODE) & 1;
    namemode = (me->p_stats.st_flags / ST_NAMEMODE) & 1;
    keeppeace = (me->p_stats.st_flags / ST_KEEPPEACE) & 1;
    showlocal = (me->p_stats.st_flags / ST_SHOWLOCAL) & 3;
    showgalactic = (me->p_stats.st_flags / ST_SHOWGLOBAL) & 3;
    state = ST_DONE;
}

makeNewGuy()
/* Make the dude with name tempname and password password1.
 * Move to state ST_DONE.
 */
{
    char *s;

    if (strcmp(password1, password2) != 0) {
	s = "Passwords do not match";
	W_WriteText(w, 100, 120, textColor, s, strlen(s), W_BoldFont);
	(void) W_EventsPending();
	sleep(3);
	W_ClearWindow(w);
	*tempname=0;
	state=ST_GETNAME;
	return;
    }
    
    /* same routine! */
    checkpassword();
}

adjustString(ch, str, defname)
char ch, *str;
char *defname;
{
    if (ch == 21) {
	*str='\0';
	if (state==ST_GETNAME) displayStartup(defname);
    } else if (ch == 8 || ch=='\177') {
	if (strlen(str)>0) {
	    str[strlen(str)-1]='\0';
	    if (state==ST_GETNAME) displayStartup(defname);
	}
    } else {
	if (strlen(str)==15) return;
	str[strlen(str)+1]='\0';
	str[strlen(str)]= ch;
	if (state==ST_GETNAME) displayStartup(defname);
    }
}

displayStartup(defname)
char *defname;
/* Draws entry screen based upon state. */
{
    char s[100];
    char *t;

    if (state == ST_DONE) return;
    t = "Enter your name.  Use the name 'guest' to remain anonymous.";
    W_WriteText(w, 100, 30, textColor, t, strlen(t), W_BoldFont);
    t = "Type ^D (Ctrl - D) to quit.";
    W_WriteText(w, 100, 40, textColor, t, strlen(t), W_BoldFont);
    sprintf(s, "Your name (default = %s): %s               ", defname, tempname);
    W_WriteText(w, 100, 50, textColor, s, strlen(s), W_BoldFont);
    if (state==ST_GETPASS) {
	t = "Enter password: ";
	W_WriteText(w, 100, 60, textColor, t, strlen(t), W_BoldFont);
    }
    if (state>ST_GETPASS) {
	t = "You need to make a password.";
	W_WriteText(w, 100, 70, textColor, t, strlen(t), W_BoldFont);
	t = "So think of a password you can remember, and enter it.";
	W_WriteText(w, 100, 80, textColor, t, strlen(t), W_BoldFont);
	t = "What is your password? :";
	W_WriteText(w, 100, 90, textColor, t, strlen(t), W_BoldFont);
    }
    if (state==ST_MAKEPASS2) {
	t = "Enter it again to make sure you typed it right.";
	W_WriteText(w, 100, 100, textColor, t, strlen(t), W_BoldFont);
	t = "Your password? :";
	W_WriteText(w, 100, 110, textColor, t, strlen(t), W_BoldFont);
    }
}

