/*
 * interface.c
 *
 * This file will include all the interfaces between the input routines
 *  and the daemon.  They should be useful for writing robots and the
 *  like 
 */
#include "copyright.h"

#include <stdio.h>
#include <math.h>
#include <signal.h>
#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

set_speed(speed)
int speed;
{
    sendSpeedReq(speed);
}

set_course(dir)
unsigned char dir;
{
    sendDirReq(dir);
}

shield_up()
{
    if (!(me->p_flags & PFSHIELD)) {
	sendShieldReq(1);
    }
}

shield_down()
{
    if (me->p_flags & PFSHIELD) {
	sendShieldReq(0);
    }
}

shield_tog()
{
    if (me->p_flags & PFSHIELD) {
	sendShieldReq(0);
    } else {
	sendShieldReq(1);
    }
}

bomb_planet()
{
    if (!(me->p_flags & PFBOMB)) {
	sendBombReq(1);
    }
}

beam_up()
{
    if (!(me->p_flags & PFBEAMUP)) {
	sendBeamReq(1);	/* 1 means up... */
    }
}

beam_down()
{
    if (!(me->p_flags & PFBEAMDOWN)) {
	sendBeamReq(2);	/* 2 means down... */
    }
}

repair()
{
    if (!(me->p_flags & PFREPAIR)) {
	sendRepairReq(1);
    }
}

repair_off()
{
    if (me->p_flags & PFREPAIR) {
	sendRepairReq(0);
    }
}

repeat_message()
{
    if (++lastm == MAXMESSAGE) ;
	lastm = 0;
}

cloak()
{
    if (me->p_flags & PFCLOAK) {
	sendCloakReq(0);
    } else {
	sendCloakReq(1);
    }
}

cloak_on()
{
    if (!(me->p_flags & PFCLOAK)) {
	sendCloakReq(1);
    }
}

cloak_off()
{
    if (me->p_flags & PFCLOAK) {
	sendCloakReq(0);
    }
}
