/*
 * smessage.c
 */
#include "copyright.h"

#include <stdio.h>
#include <math.h>
#include <signal.h>
#include <ctype.h>
#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"

#define ADDRLEN 10

#define BLANKCHAR(col, n) W_ClearArea(messagew, 5+W_Textwidth*(col), 5, \
    W_Textwidth * (n), W_Textheight, backColor);
#define DRAWCURSOR(col) W_WriteText(messagew, 5+W_Textwidth*(col), 5, \
    textColor, &cursor, 1, W_RegularFont);

static int lcount;
static char buf[80];
static char cursor = '_';

char *getaddr(), *getaddr2();

smessage(ichar)
    char ichar;
{
    register int i;
    char *getaddr();
    char twochar[2];
    static char addr, *addr_str;

    if (messpend == 0) {
	messpend = 1;
	if (mdisplayed) {
	    BLANKCHAR(0, lastcount);
	    mdisplayed = 0;
	}
	/* Put the proper recipient in the window */
	if ((ichar == 't') || (ichar == 'T'))
	    addr = teamlet[me->p_team];
	else
	    addr = ichar;
	addr_str = getaddr(addr);
	if (addr_str == 0) {
	    /* print error message */
	    messpend = 0;
	    return;
	}
	W_WriteText(messagew, 5, 5, textColor, addr_str, strlen(addr_str),
	    W_RegularFont);
	lcount = ADDRLEN;
	DRAWCURSOR(ADDRLEN);
	return;
    }
    switch ((unsigned char)ichar & ~(0x80)) {
	case '\b':	/* character erase */
	case '\177':
	    if (--lcount < ADDRLEN) {
		lcount = ADDRLEN;
		break;
	    }
	    BLANKCHAR(lcount + 1, 1);
	    DRAWCURSOR(lcount);
	    break;

	case '\027':	/* word erase */
	    i = 0;
	    /* back up over blanks */
	    while (--lcount >= ADDRLEN &&
		isspace((unsigned char)buf[lcount - ADDRLEN] & ~(0x80)))
		i++;
	    lcount++;
	    /* back up over non-blanks */
	    while (--lcount >= ADDRLEN &&
		!isspace((unsigned char)buf[lcount - ADDRLEN] & ~(0x80)))
		i++;
	    lcount++;

	    if (i > 0) {
		BLANKCHAR(lcount, i + 1);
		DRAWCURSOR(lcount);
	    }
	    break;

	case '\025':	/* kill line */
	case '\030':
	    if (lcount > ADDRLEN) {
		BLANKCHAR(ADDRLEN, lcount - ADDRLEN + 1);
		lcount = ADDRLEN;
		DRAWCURSOR(ADDRLEN);
	    }
	    break;

	case '\033':	/* abort message */
	    BLANKCHAR(0, lcount + 1);
	    mdisplayed = 0;
	    messpend = 0;
	    break;

	case '\r':	/* send message */
	    buf[lcount - ADDRLEN] = '\0';
	    messpend = 0;
	    switch (addr) {
		case 'A':
		    pmessage(buf, 0, MALL);
		    break;
		case 'F':
		    pmessage(buf, FED, MTEAM);
		    break;
		case 'R':
		    pmessage(buf, ROM, MTEAM);
		    break;
		case 'K':
		    pmessage(buf, KLI, MTEAM);
		    break;
		case 'O':
		    pmessage(buf, ORI, MTEAM);
		    break;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		    pmessage(buf, addr - '0', MINDIV);
		    break;
		case 'a': case 'b': case 'c': case 'd':
		case 'e': case 'f': case 'g': case 'h':
		case 'i': case 'j': case 'k': case 'l':
		case 'm': case 'n': case 'o': case 'p':
		case 'q': case 'r': case 's': case 't': 
		case 'u': case 'v': case 'w': case 'x': 
		case 'y': case 'z':
		    pmessage(buf, addr - 'a' + 10, MINDIV);
		    break;
		default:
		    warning("Not legal recipient");
	    }
	    BLANKCHAR(0, lcount + 1);
	    mdisplayed = 0;
	    lcount = 0;
	    break;

	default:	/* add character */
	    if (lcount >= 80) {
		W_Beep();
		break;
	    }
	    if (iscntrl((unsigned char )ichar & ~(0x80)))
		break;
	    twochar[0] = ichar;
	    twochar[1] = cursor;
	    W_WriteText(messagew, 5 + W_Textwidth * lcount, 5, textColor,
		twochar, 2, W_RegularFont);
	    buf[(lcount++) - ADDRLEN] = ichar;
	    break;
    }
}

pmessage(str, recip, group)
char *str;
int recip;
int group;
{
    char newbuf[100];

    sendMessage(str, group, recip);
    if ((group==MTEAM && recip!=me->p_team) || 
	(group==MINDIV && recip!=me->p_no)) {
	sprintf(newbuf, "%s  %s", getaddr2(group, recip), str);
	newbuf[79]=0;
	dmessage(newbuf, group, me->p_no, recip);
    }
}

char *getaddr(who)
char who;
{
    switch (who) {
    case 'A':
	return(getaddr2(MALL, 0));
    case 'F':
	return(getaddr2(MTEAM, FED));
    case 'R':
	return(getaddr2(MTEAM, ROM));
    case 'K':
	return(getaddr2(MTEAM, KLI));
    case 'O':
	return(getaddr2(MTEAM, ORI));
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
	if (isAlive(&players[who - '0'])) {
	    return(getaddr2(MINDIV, who-'0'));
	}
	else {
	    warning("Player is not in game");
	    return(0);
	}
	break;
    case 'a': case 'b': case 'c': case 'd':
    case 'e': case 'f': case 'g': case 'h':
    case 'i': case 'j': case 'k': case 'l':
    case 'm': case 'n': case 'o': case 'p':
    case 'q': case 'r': case 's': case 't': 
    case 'u': case 'v': case 'w': case 'x': 
    case 'y': case 'z':
	if (who-'a'+10 > MAXPLAYER) {
	    warning("Player is not in game");
	    return(0);
	}
	if (isAlive(&players[who - 'a' + 10])) {
	    return(getaddr2(MINDIV, who-'a'+10));
	}
	else {
	    warning("Player is not in game");
	    return(0);
	}
	break;
    default:
	warning("Not legal recipient");
	return(0);
    }
}

char *getaddr2(flags, recip) 
int flags;
int recip;
{
    static char addrmesg[ADDRLEN];

    (void) sprintf(addrmesg, " %c%c->", teamlet[me->p_team], shipnos[me->p_no]);
    switch(flags) {
    case MALL:
	(void) sprintf(&addrmesg[5], "ALL");
	break;
    case MTEAM:
	(void) sprintf(&addrmesg[5], teamshort[recip]);
	break;
    case MINDIV:
	(void) sprintf(&addrmesg[5], "%c%c ",
	    teamlet[players[recip].p_team], shipnos[recip]);
	break;
    }
    return(addrmesg);
}

/* Send an emergency signal out to everyone. */

emergency()
{
    char addrbuf[ADDRLEN];
    char ebuf[80];

    if (myship->s_type==STARBASE) {
	sprintf(ebuf, 
	    "Distress Call from %c%c (Starbase!):  %d%% damage, %d%% shields, %d armies!",
	    teamlet[me->p_team], shipnos[me->p_no],
	    (100*me->p_damage)/me->p_ship.s_maxdamage,
	    (100*me->p_shield)/me->p_ship.s_maxshield,
	    me->p_armies);
    } else {
	sprintf(ebuf, 
	    "Distress Call from %c%c:  %d%% damage, %d%% shields, %d armies!",
	    teamlet[me->p_team], shipnos[me->p_no],
	    (100*me->p_damage)/me->p_ship.s_maxdamage,
	    (100*me->p_shield)/me->p_ship.s_maxshield,
	    me->p_armies);
    }
    pmessage(ebuf, me->p_team, MTEAM);
}
