/* 
 * death.c
 */
#include "copyright.h"

#include <stdio.h>
#include <signal.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/time.h>
#include "defs.h"
#include "struct.h"
#include "data.h"

extern jmp_buf env;

static struct itimerval udt;

death()
{
    char buf[80];
    int i,j,k,first;

    signal(SIGALRM, SIG_IGN);
    udt.it_interval.tv_sec = 0;
    udt.it_interval.tv_usec = 0;
    udt.it_value.tv_sec = 0;
    udt.it_value.tv_usec = 0;
    setitimer(ITIMER_REAL, &udt, 0);

    me->p_status = POUTFIT;             /* Stop the ghost buster */

    switch(me->p_whydead) {
    case KTORP:
    case KPLASMA:
    case KPHASER:
    case KPLANET:
    case KSHIP:
    case KGENOCIDE:
    case KGHOST:
    case KPROVIDENCE:
	break;
    case KQUIT:
    case KDAEMON:
    case KWINNER:
    default:
	mustexit = 1;
	break;
    }

    me->p_flags &= ~(PFWAR|PFREFITTING);

    /* First we check for promotions: */
    if (me->p_stats.st_rank < NUMRANKS-1) {
        float ratingTotals;
        char buf[100];

        ratingTotals=planetRating(me) + bombingRating(me) + offenseRating(me);
        /* The person is promoted if they have enough hours and their ratings
         * are high enough, or if it is clear that they could sit around and
         * do nothing for the amount of time required, and still make the rank.
         * (i.e. their 'DI' rating is about rank.hours * rank.ratings ad they
         *  have insufficient time yet).
         */
        if (defenseRating(me) >= ranks[mystats->st_rank + 1].defense &&
            ((mystats->st_tticks/36000.0 >= ranks[mystats->st_rank + 1].hours/hourratio &&
             ratingTotals >= ranks[mystats->st_rank + 1].ratings) ||
            (mystats->st_tticks/36000.0 < ranks[mystats->st_rank + 1].hours/hourratio &&
             ratingTotals*(mystats->st_tticks/36000.0) >=
             ranks[mystats->st_rank+1].hours/hourratio*ranks[mystats->st_rank+1].ratings))
) {
            mystats->st_rank ++;
        } else if 
	    /* We also promote if they belong in their current rank, but have
	     * twice enough DI for the next rank.
	     */
	    ((defenseRating(me) >= ranks[mystats->st_rank].defense &&
	      ratingTotals >= ranks[mystats->st_rank].ratings) && 
	     ratingTotals*(mystats->st_tticks/36000.0) >= 
	     ranks[mystats->st_rank+1].hours/hourratio*ranks[mystats->st_rank+1].ratings*2) {
	    mystats->st_rank ++;
	} else if 
	    /* We also promote if they belong down a rank, but have four
	     * times the DI for the next rank.
	     */
	    (mystats->st_rank > 0 &&
	     (defenseRating(me) >= ranks[mystats->st_rank-1].defense &&
	      ratingTotals >= ranks[mystats->st_rank-1].ratings) &&
	     ratingTotals*(mystats->st_tticks/36000.0) >=
	     ranks[mystats->st_rank+1].hours/hourratio*ranks[mystats->st_rank+1].ratings*4) {
	    mystats->st_rank++;
	}
    }
    updateClient();
    /* Give them one more update now... */
    savestats();
    longjmp(env, 0);
}
