/*
 * detonate.c
 */
#include "copyright.h"

#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include "defs.h"
#include "struct.h"
#include "data.h"

/* Detonate torp */

/*
** Here we have another flaw.  Detonating other players torps can be a
** very quick way to die.  Why?  Because you always take some damage.
** Experienced players never detonate other players' torps.  Balance is
** really hard to obtain with this type of function.  Technically, a
** player could nearly continuously detonate torps (at least faster than
** they could be fired) and never be hurt, if I allowed less damage as
** a possible result.  So here it sits.
*/

detothers()
{
    register int h, i;
    int dx, dy;
    register struct torp *j;

    if (me->p_fuel < myship->s_detcost) {
	warning("Not enough fuel to detonate");
	return;
    }
    if (me->p_flags & PFWEP) {
	warning("Weapons overheated");
	return;
    }
    me->p_fuel -= myship->s_detcost;
    me->p_wtemp += myship->s_detcost / 5;

    for (h = 0; h < MAXPLAYER; h++) {
	if ((players[h].p_status == PFREE) || (h == me->p_no))
	    continue;
	for (i = h * MAXTORP; i < MAXTORP * (h + 1); i++) {
	    j = &torps[i];
	    if (friendlyTorp(j)) continue;
	    if ((j->t_status == TMOVE) || (j->t_status == TSTRAIGHT)) {
		dx = j->t_x - me->p_x;
		dy = j->t_y - me->p_y;
		if (ABS(dx) > DETDIST || ABS(dy) > DETDIST) /* XXX */
		    continue;
		if (dx * dx + dy * dy < DETDIST * DETDIST) { /* bug fix: braces were missing, resulting in a square det radius 6/22/92 TC */
		    j->t_whodet = me->p_no;
		    j->t_status = TDET;
		}
	    }
	}
    }
}
