/*
 * enter.c
 */
#include "copyright.h"

#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <errno.h>
#include <pwd.h>
#include <string.h>
#include <ctype.h>
#include <time.h>		/* 7/16/91 TC */
#include "defs.h"
#include "struct.h"
#include "data.h"

/* Enter the game */

long random();

/* change 5/10/91 TC -- if tno == 4, independent */
				/* tno == 5 Terminator */
enter(tno, disp, pno, s_type)
int tno;
int disp;			/* not used, so I used it 7/27/91 TC */
int pno;
int s_type;
{
    static int lastteam= -1;
    static int lastrank= -1;
    char buf[80];
    char addrbuf[10];
    int startplanet;

    (void) strncpy(me->p_name, pseudo, sizeof (me->p_name));
    me->p_name[sizeof(me->p_name) - 1] = '\0';
    getship(myship, s_type);
    /* Need 2 kills to use plasma torpedoes */
    if ((s_type != STARBASE) && (s_type != ATT) && plkills>0) {
	me->p_ship.s_plasmacost = -1;
    }
    me->p_updates = 0;
    me->p_flags = PFSHIELD;
    if (s_type==STARBASE) me->p_flags |= PFDOCKOK;
    me->p_dir = 0;
    me->p_desdir = 0;
    me->p_speed = 0;
    me->p_desspeed = 0;
    me->p_subspeed = 0;
    if ((tno == 4) || (tno == 5)) { /* change 5/10/91 TC new case, indep */
	me->p_team = 0;
	placeIndependent();	/* place away from others 1/23/92 TC */
    }
    else {
	me->p_team = (1 << tno);
	for (;;) {
	    startplanet=tno*10 + random() % 10;
	    if (startplanets[startplanet]) break;
	}
	me->p_x = planets[startplanet].pl_x + (random() % 10000) - 5000;
	me->p_y = planets[startplanet].pl_y + (random() % 10000) - 5000;
	if (me->p_x < 0) me->p_x=0;
	if (me->p_y < 0) me->p_y=0;
	if (me->p_x > GWIDTH) me->p_x = GWIDTH;
	if (me->p_y > GWIDTH) me->p_y = GWIDTH;
    }
    me->p_ntorp = 0;
    me->p_cloakphase = 0;
    me->p_nplasmatorp = 0;
    me->p_damage = 0;
    me->p_subdamage = 0;
    me->p_etemp = 0;
    me->p_etime = 0;
    me->p_wtemp = 0;
    me->p_wtime = 0;
    me->p_shield = me->p_ship.s_maxshield;
    me->p_subshield = 0;
    me->p_swar = 0;
    me->p_kills = 0.0;
    me->p_armies = 0;
    me->p_docked = 0;
    me->p_port[0] = VACANT;
    me->p_port[1] = VACANT;
    me->p_port[2] = VACANT;
    me->p_port[3] = VACANT;
/*    if (!keeppeace) me->p_hostile = (FED|ROM|KLI|ORI);*/
    if (!keeppeace) auto_peace();
    me->p_hostile &= ~me->p_team;

    /* join message stuff */

    sprintf(buf, "%c%c", teamlet[me->p_team], shipnos[me->p_no]);
    strncpy(me->p_mapchars, buf, 2);
    if (lastteam != tno || lastrank != mystats->st_rank) {
	char buf[80];

	/* If switching, become hostile to former team 6/29/92 TC */
	
	if ((lastteam > 0) && (lastteam < NUMTEAM) && (lastteam != tno)) {
	    declare_war(1<<lastteam);
	}
	lastteam=tno;
	lastrank=mystats->st_rank;
	sprintf(addrbuf, " %c%c->ALL", 
	    teamlet[me->p_team], shipnos[me->p_no]);
	if ((tno == 4) && (strcmp(me->p_monitor, "Nowhere") == 0)) {
	    /* change 5/10/91, 8/28/91 TC */
	    long curtime;
	    struct tm *tmstruct;
	    char buf2[40];
	    int queuesize;
	    int hour;

	    time(&curtime);
	    tmstruct = localtime(&curtime);
	    if (!(hour = tmstruct->tm_hour%12)) hour = 12;
	    sprintf(buf, "It's %d:%02d%s, time to die.", hour, tmstruct->tm_min,
		    tmstruct->tm_hour >= 12 ? "pm" : "am");
	    if ((queuesize = status->count - status->wait) > 0) {
		sprintf(buf2, "  Approximate queue size: %d.", status->answer);
		strcat(buf, buf2);
	    }
	    pmessage2(buf, 0, MALL, addrbuf, me->p_no);
	}
	else if (tno == 5) {		/* change 7/27/91 TC */
	    char buf2[80];

	    if (players[disp].p_status != PFREE) {
		sprintf(buf2, "%c%c has been targeted for termination.",
			teamlet[players[disp].p_team],
			shipnos[players[disp].p_no]);
		pmessage2(buf2, 0, MALL, addrbuf, me->p_no);
	    }
	}

#ifndef FULL_HOSTNAMES
	/* old-style join message 4/13/92 TC */
	sprintf(buf, "%s %.16s joining as %2.2s (%.16s@%.16s)", 
		ranks[me->p_stats.st_rank].name, 
		me->p_name, 
		me->p_mapchars, 
		me->p_login,
		me->p_monitor);
#else
	/* new-style join message 4/13/92 TC */
	sprintf(buf, "%s %.16s is now %2.2s (%.16s@%.32s)", 
		ranks[me->p_stats.st_rank].name, 
		me->p_name, 
		me->p_mapchars, 
		me->p_login,
		me->p_full_hostname);
#endif

	pmessage2(buf, 0, MALL | MJOIN, addrbuf, me->p_no);
    }

    me->p_fuel = myship->s_maxfuel;
    delay = 0;
}

/* my idea of avoiding using the war window 8/16/91 TC */
auto_peace()
{
    int i, num[MAXTEAM+1];	/* corrected 6/22/92 TC */
    struct player	*p;

    num[0] = num[FED] = num[ROM] = num[KLI] = num[ORI] = 0;
    for (i = 0, p = players; i < MAXPLAYER; i++, p++)
	if (p->p_status != PFREE)
	    num[p->p_team]++;
    if (status->tourn)
	me->p_hostile = 
	    ((FED * (num[FED] >= tournplayers)) |
	     (ROM * (num[ROM] >= tournplayers)) |
	     (KLI * (num[KLI] >= tournplayers)) |
	     (ORI * (num[ORI] >= tournplayers)));
    else
	me->p_hostile = FED|ROM|KLI|ORI;
}

/* code to avoid placing bots on top of others 1/23/92 TC */

#define INDEP (GWIDTH/3)	/* width of region they can enter */

placeIndependent()
{
    int i;
    struct player	*p;
    int good, failures;

    failures = 0;
    while (failures < 10) {	/* don't try too hard to get them in */
	me->p_x = GWIDTH/2 + (random() % INDEP) - INDEP/2; /* middle 9th of */
	me->p_y = GWIDTH/2 + (random() % INDEP) - INDEP/2; /* galaxy */
	good = 1;
	for (i = 0, p = players; i < MAXPLAYER; i++, p++)
	    if ((p->p_status != PFREE) && (p != me)) {

		/* was 5 tries, was < TRACTDIST 7/20/92 TC */
		if ((ABS(p->p_x - me->p_x) < 2*TRACTDIST) && /* arbitrary def */
		    (ABS(p->p_y - me->p_y) < 2*TRACTDIST)) { /* of too close */
		    failures++;
		    good = 0;
		    break;
		}
	    }
	if (good) return;
    }
    fprintf(stderr, "Couldn't place the bot successfully.\n");
}

openmem()
{
    extern int errno;
    int	shmemKey = PKEY;
    int	shmid;
    struct memory	*sharedMemory;

    errno = 0;
    shmid = shmget(shmemKey, 0, 0);
    if (shmid < 0) {
	if (errno != ENOENT) {
	    perror("shmget");
	    exit(1);
	}
	startdaemon();
	sleep(2);
	shmid = shmget(shmemKey, 0, 0);
	if (shmid < 0) {
	    fprintf(stderr, "Daemon not running (err:%d)\n",errno);
	    exit (1);
	}
    }
    sharedMemory = (struct memory *) shmat(shmid, 0, 0);
    if (sharedMemory == (struct memory *) -1) {
	perror("shared memory");
	exit (1);
    }
    players = sharedMemory->players;
    torps = sharedMemory->torps;
    plasmatorps = sharedMemory->plasmatorps;
    status = sharedMemory->status;
    planets = sharedMemory->planets;
    phasers = sharedMemory->phasers;
    mctl = sharedMemory->mctl;
    messages = sharedMemory->messages;
    teams = sharedMemory->teams;
}




