static char rcsid[] = "$Header: /usr/users/terence/src/xtrek/ntserv/RCS/getentry.c,v 1.3 92/03/19 21:34:43 terence Exp $";

/* $Log:	getentry.c,v $
 * Revision 1.3  92/03/19  21:34:43  terence
 * Added UDP mods (version 0.2, 3/17/92)
 * 
 * Revision 1.2  92/03/11  15:51:55  terence
 * added UDP mods
 *  */

/*
 * getentry.c
 *
 * Kevin P. Smith  1/31/89
 *
 * Get an outfit and team entry request from user.
 */
#include "copyright.h"

#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

extern int overload;		/* 7/31/91 TC let overloaded join any team */

getEntry(team, stype)
int *team;
int *stype;
{
    int i;
    extern char start_pseudo[], start_login[]; /* change 1/28/91 TC */

    int switching = -1;		/* confirm switches 7/27/91 TC */

    inputMask=CP_OUTFIT;
    for (;;) {
	/* updateShips so he knows how many players on each team */
	updateShips();
	sendMaskPacket(tournamentMask(me->p_team));
	flushSockBuf();		
	/* Have we been busted? */
	if (me->p_status == PFREE) {
	    me->p_status=PDEAD;
	    me->p_explode=600;
	}
	socketPause();
	readFromClient();
	if (isClientDead()) {
	    int i;

	    if (noressurect) exitGame(0);
	    printf("Ack!  The client went away!\n");
	    printf("I will attempt to resurrect him!\n");

	    /* UDP fail-safe */
	    commMode = COMM_TCP;
	    if (udpSock >= 0)
		closeUdpConn();

	    /* For next two minutes, we try to restore connection */
	    shutdown(sock, 2);
	    sock= -1;
	    for (i=0;; i++) {
		switch(me->p_status) {
		case PFREE:
		    me->p_status=PDEAD;
		    me->p_explode=600;
		    break;
		case PALIVE:
		    me->p_ghostbuster=0;
		    break;
		case PDEAD:
		    me->p_explode=600;
		    break;
		default:
		    me->p_explode=600;
		    me->p_ghostbuster=0;
		    break;
		}
		sleep(5);
		if (connectToClient(host, nextSocket)) break;
		if (i==23) {
		    printf("Oh well, maybe I'm getting rusty!\n");
		    switch(me->p_status) {
		    case PFREE:
			break;
		    case PALIVE:
			me->p_ghostbuster=1000000; 
			break;
		    case PDEAD:
			me->p_explode=0;
			break;
		    default:
			me->p_explode=0;
			me->p_ghostbuster=1000000;
			break;
		    }
		    exitGame(0);
		}
	    }
	    printf("A miracle!  He's alive!\n");
	    teamPick= -1;
	    updateSelf();
	    updateShips();
	    flushSockBuf();
	}
	if (teamPick != -1) {
	    if (teamPick < 0 || teamPick > 3) {
		warning("Get real!");
		sendPickokPacket(0);
		teamPick= -1;
		continue;
	    } 
	    if (!(tournamentMask(me->p_team) & (1<<teamPick))) {
		warning("I cannot allow that.  Pick another team");
		sendPickokPacket(0);
		teamPick= -1;
		continue;
	    }

	    if (((1<<teamPick) != me->p_team) &&
		(me->p_team != ALLTEAM)) /* switching teams 7/27/91 TC */
		if ((switching != teamPick) && (me->p_whydead != KGENOCIDE)) {
		    switching = teamPick;
		    warning("Please confirm change of teams.  Select the new team again.");
		    sendPickokPacket(0);
		    teamPick= -1;
		    continue;
		}

	    /* His team choice is ok. */
	    if (shipPick<0 || shipPick>=ATT) {
		warning("That is an illegal ship type.  Try again.");
		sendPickokPacket(0);
		teamPick= -1;
		continue;
	    }
	    if (shipsallowed[shipPick]==0) {
		warning("That ship hasn't beed designed yet.  Try again.");
		sendPickokPacket(0);
		teamPick= -1;
		continue;
	    }
	    if (shipPick==STARBASE) {
		if (teams[1<<teamPick].s_turns > 0 && !chaos && !topgun) {
		    warning("Your new starbase is still under construction");
		    sendPickokPacket(0);
		    teamPick= -1;
		    continue;
		}
		if (mystats->st_rank < sbrank) {
		    char buf[100];

		    sprintf(buf, "You need a rank of %s or higher to command a starbase!", ranks[sbrank].name);
		    warning(buf);
		    sendPickokPacket(0);
		    teamPick= -1;
		    continue;
		}
		if (numShips(1<<teamPick) < 3 && !chaos && !topgun) {
		    warning("Your team is not capable of defending such an expensive ship!");
		    sendPickokPacket(0);
		    teamPick= -1;
		    continue;
		}
		if (numPlanets(1<<teamPick) < 5 && !chaos && !topgun) {
		    warning("Your team's stuggling economy cannot support such an expenditure!");
		    sendPickokPacket(0);
		    teamPick= -1;
		    continue;
		}
		for (i=0; i<MAXPLAYER; i++) {
		    if (i != me->p_no &&
			players[i].p_status == PALIVE &&
			players[i].p_team == (1<<teamPick) &&
			players[i].p_ship.s_type == STARBASE && !chaos) {
			warning("Your side already has a starbase!");
			sendPickokPacket(0);
			teamPick= -1;
			break;
		    }
		}
	    }
	    if (teamPick==-1) continue;
	    break;
	}
    }
    *team=teamPick;
    *stype=shipPick;
    sendPickokPacket(1);
    flushSockBuf();
}

int diagnolTeams[9] = { 0, KLI, ORI, 0, FED, 0, 0, 0, ROM };

tournamentMask(team)
int team;
{
    int i, team1=0, team2=0, num1=0, num2=0;
    int largest, largecount;
    int second;
    int rns;

    if (status->gameup==0) return(0);
    if (chaos || topgun || overload) return(ALLTEAM);
    if (mustexit) return(0);
    if (team != ALLTEAM && deadTeam(team)) {
        team=ALLTEAM;
    }
    if (team != ALLTEAM && realNumShips(diagnolTeams[team]) >= tournplayers) {
	team=ALLTEAM;
    }
    for (i=0; i<NUMTEAM; i++) {	/* maint: was "i<4" 6/22/92 TC */
        if (!(team & (1<<i))) continue;
        if (deadTeam(1<<i)) {
            team &= ~(1<<i);
        }
	if (!deadTeam(diagnolTeams[1<<i]) && 
	      realNumShips(diagnolTeams[1<<i]) >= tournplayers) {
	    team &= ~(1<<i);
	}
    }

    /* if first time, check for tournament rules */
/*    for (i = 0; i < tournplayers; i++) { say what? bug fix TC */
    for (i = 0; i < NUMTEAM; i++) { /* maint: was "i < 4" 6/22/92 TC */
	if (deadTeam(1<<i)) continue;
	if (realNumShips(1<<i) >= tournplayers) {
	    if (!team1) {
		team1 = (1<<i);
	    } else {
		team2 = (1<<i);
	    }
	    if (team2) {
		num1 = realNumShips(team1);
		num2 = realNumShips(team2);
		if (ABS(num1 - num2) < 1) { /* was 2 -- 7/25/91 TC */
		    if (team & (team1 | team2)) {
			return(team & (team1 | team2));
		    }
                    return(team1 | team2);
		} else if ((num1>num2) && (team != team1)) {
		    return(team2);
		} else if ((num1<num2) && (team != team2)) {
		    return(team1);
		} else {
		    if (ABS(num1 - num2) < 2 ||	/* was 2 -- 7/25/91 TC */
			((num1>num2 && team==team2) ||
			 (num2>num1 && team==team1)))
			return(team);
		    else
			/* Give them choice if their own team is too strong */
			return(team1 | team2);
		}
            }
        }
    }

    /* more team selection code 2/27/92 TC */

    /* okay, there's a pathological case not covered where it's not tmode,
       we have enough players for tmode, but only one or none of the teams
       have tournplayers (and they won't quit due to the queue) */

    /* First we need the total number of players and the largest team */

    num1 = 0;
    largest = 0;
    largecount = 0;
    for (i = 0; i < NUMTEAM; i++) { /* maint: was "i < 4" 6/22/92 TC */
	rns = realNumShips(1<<i); /* really shouldn't include robots */
	num1 += rns;
	if (rns > largecount) { largecount = rns; largest = 1<<i; }
    }

    if (status->tourn) return team; /* shouldn't be necessary */
    if (num1 < tournplayers+tournplayers) return (team); /* non Tmode case */

    /* okay, we *could* have tmode if we added players to the largest of the
       two teams that are adjacent to the overall largest team, so let's
       find out who needs players; a 4-way tie would be even more pathological
       but this code will break ties in a deterministic fashion */

    /* for "largest", precedence order is Fed, Rom, Kli, Ori */
    /* "second" will have less or equal # of players as "largest" */

    switch (largest) {
      case FED:			/* Ori == Rom => Rom 2nd */
      case KLI:
	second = realNumShips(ORI) > realNumShips(ROM) ? ORI : ROM;
	break;
      case ROM:			/* Kli == Fed => Fed 2nd */
      case ORI:
	second = realNumShips(KLI) > realNumShips(FED) ? KLI : FED;
	break;
    }

    /* if most players are on a non-viable team just return */

    if (deadTeam(largest) || deadTeam(second))
	return team;

    /* case 1:  player is not on largest or second, offer shorthanded ones */
    
    if ((team <= ORI) && (team != largest) && (team != second)) {
	if (largecount < tournplayers)
	    return (team | largest | second);
	else
	    return (team | second);
    }

    /* case 2:  player is on largest, so offer second if largest can spare */
    /* a player */

    if ((team <= ORI) && (team == largest) && (largecount > tournplayers))
	return(team | second);

    return team;
}

realNumShips(owner)
int owner;
{
    int             i, num = 0;
    struct player   *p;

    for (i = 0, p = players; i < MAXPLAYER; i++, p++) {
	if (p->p_status != PFREE &&
	    p->p_team == owner) {
	    num++;
	}
    }
    return (num);
}

deadTeam(owner)
int owner;
{
    int i,num=0;
    struct planet *p;

/*    return 1;			/* server off */
    if (!time_access()) return 1; /* 8/2/91 TC */
    if (planets[remap[owner]*10-10].pl_couptime == 0) return(0);
    for (i=0, p=planets; i<MAXPLANETS; i++,p++) {
        if (p->pl_owner & owner) {
            num++;
        }
    }
    if (num!=0) return(0);
    return(1);
}

