static char rcsid[] = "$Header: /usr/users/terence/src/xtrek/ntserv/RCS/input.c,v 1.4 92/03/19 21:34:40 terence Exp $";

/* $Log:	input.c,v $
 * Revision 1.4  92/03/19  21:34:40  terence
 * Added UDP mods (version 0.2, 3/17/92)
 * 
 * Revision 1.3  92/03/11  23:36:50  terence
 * added Tedd Hadley's snippet fix:
 * 
 *         FD_ZERO(&readfds);
 *         FD_SET(sock, &readfds);
 *         if (udpSock >= 0)
 *                 FD_SET(udpSock, &readfds);
 *         if (select(32, &readfds, 0, 0, &timeout) != 0) {
 *             readFromClient();
 *         }
 * 
 * Revision 1.2  92/03/11  15:53:31  terence
 * added UDP mods
 *  */

/*
 * input.c
 */
#include "copyright.h"

#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include <sys/time.h>
#include <signal.h>
#include <errno.h>
#include "defs.h"
#include "struct.h"
#include "data.h"

static int sendflag=0;

setflag()
{
    sendflag=1;
}

input()
{
    int fd, nchar;
    struct itimerval	udt;
    struct timeval timeout;
    /*int readfds;*/
    fd_set readfds;

    udt.it_interval.tv_sec = 0;
    udt.it_interval.tv_usec = timerDelay;
    udt.it_value.tv_sec = 0;
    udt.it_value.tv_usec = timerDelay;
    setitimer(ITIMER_REAL, &udt, 0);
    signal(SIGALRM, setflag);

    /* Idea:  read from client often, send to client not so often */
    while (1) {
	if (isClientDead()) {
	    int i;
	    char buf[80];

	    if (noressurect) exit(0);
	    udt.it_interval.tv_sec = 0;
	    udt.it_interval.tv_usec = 0;
	    udt.it_value.tv_sec = 0;
	    udt.it_value.tv_usec = 0;
	    setitimer(ITIMER_REAL, &udt, 0);
	    signal(SIGALRM, SIG_IGN);
	    printf("Ack!  The client went away!\n");
	    printf("I will attempt to resurrect him!\n");

	    /* UDP fail-safe */
	    commMode = COMM_TCP;
            if (udpSock >= 0)
		closeUdpConn();

	    /* For next two minutes, we try to restore connection */
	    shutdown(sock, 2);
	    sock= -1;
	    for (i=0;; i++) {
		me->p_ghostbuster = 0;
		sleep(5);
		if (connectToClient(host, nextSocket)) break;
		if (i==23) {
		    printf("Oh well, maybe I'm getting rusty!\n");
		    exit(0);
		}
	    }
	    udt.it_interval.tv_sec = 0;
	    udt.it_interval.tv_usec = timerDelay;
	    udt.it_value.tv_sec = 0;
	    udt.it_value.tv_usec = timerDelay;
	    setitimer(ITIMER_REAL, &udt, 0);
	    signal(SIGALRM, setflag);
	    printf("A miracle!  He's alive!\n");
	}
	timeout.tv_sec=0;
	timeout.tv_usec= 50000;
/*	readfds=(1<<sock);*/
        FD_ZERO(&readfds);
        FD_SET(sock, &readfds);
        if (udpSock >= 0)
                FD_SET(udpSock, &readfds);
	if (select(32, &readfds, 0, 0, &timeout) != 0) {
	    readFromClient();
	}
	if (me->p_updates > delay) {
	    me->p_flags &= ~(PFWAR);
	}
	if (me->p_updates > rdelay) {
	    me->p_flags &= ~(PFREFITTING);
	}
	/* Keep self from being nuked... */
	me->p_ghostbuster = 0;
	if (sendflag) {
	    intrupt();
	    sendflag=0;
	}

    }
}


