/*
 * main.c
 */
#include "copyright.h"

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <signal.h>
#include <setjmp.h>
#include <pwd.h>
#include <sys/time.h>
#include <sys/wait.h>
#include "defs.h"
#include "struct.h"
#include "data.h"
/* #include "templates.h" */
#include "packets.h"

jmp_buf env;
int startTkills, startTlosses, startTarms, startTplanets, startTticks;
char start_login[16];		/* change 1/25/91 TC */
char start_name[16];		/* change 1/25/91 TC */
int goAway = 0;			/* change 4/14/91 TC */
int ignored[MAXPLAYER];		/* change 7/24/91 TC */

int overload = 0;		/* global 7/31/91 TC */
/* overload indicates a request for a reserved slot */

int indie = 0;			/* always be indie 8/28/91 TC */

main(argc, argv)
int argc;
char **argv;
{
    int intrupt();
    int team, s_type;
    int pno;
    int usage = 0;
    int err = 0;
    char *cp, *name, *ptr, *rindex();
    char buf[80];
    struct passwd *pwent, *getpwuid();
    int reaper();
    int callHost=0;
    long starttime;

    name = *argv++;
    argc--;
    if ((ptr = rindex(name, '/')) != NULL)
	name = ptr + 1;
    while (*argv) {
	if (**argv == '-')
	    ++*argv;
	else
	    break;

	argc--;
	ptr = *argv++;
	while (*ptr) {
	    switch (*ptr) {
	    case 'u': usage++; break;
	    case 'i': indie++; break; /* 8/28/91 TC */
	    case 'R': if (getuid()==geteuid()) overload++; break;
	    case 's': xtrekPort=atoi(*argv); callHost=1; argv++; argc--; break;
	    case 'd':
		host = *argv;
		argc--;
		argv++;
		break;
	    default: 
		fprintf(stderr, "%s: unknown option '%c'\n", name, *ptr);
		err++;
		break;
	    }
	    ptr++;
	}
    }
    if (usage || err) {
	printUsage(name);
	exit(err);
    }
    /* compatability */
    if (argc > 0)
	host = argv[0];
    srandom(getpid() * time((long *) 0));
    readsysdefaults();
    /* this finds the shared memory information */
    openmem();
    me = NULL;			/* UDP fix (?) */
    if (callHost) {
	if (!connectToClient(host,xtrekPort)) {
	    exit(0);
	}
    } else {
	sock=0;	/* Because we were forked by inetd! */
	checkSocket();
	initClientData();	/* "normally" called by connectToClient() */
    }
    starttime=time(NULL);
    while (userVersion==0) {
	/* Waiting for user to send his version number.
	 * We give him ten seconds to do so...
	 */
	if (starttime+10 < time(NULL)) {
	    exit(1);
	}
	socketPause();
	readFromClient();
    }
    if (!checkVersion()) exit(1);
    sendMotd();
    pno = findslot(overload);
    if (pno < 0) {
	/* print some appropriate message */
	exit(1);
    }
    me = &players[pno];
    me->p_no=pno;
    myship = &me->p_ship;
    mystats = &me->p_stats;
    lastm = mctl->mc_current;
    signal(SIGINT, SIG_IGN);
    (void) signal(SIGCHLD, reaper);

    /* We set these so we won't bother updating him on the location of the
     *  other players in the galaxy which he is not near.  There is no
     *  real harm to doing this, except that he would then get more information
     *  than he deserves.
     * It is kind of a hack, but should be harmless.
     */
    me->p_x= -100000;	
    me->p_y= -100000;
    me->p_team=0;
    updateSelf();	/* so he gets info on who he is */
    updateShips();
    updatePlanets();
    flushSockBuf();

    /* Get login name */

    if ((pwent = getpwuid(getuid())) != NULL)
	(void) strncpy(login, pwent->pw_name, sizeof(login));
    else
	(void) strncpy(login, "Bozo", sizeof(login));
    login[sizeof(login) - 1] = '\0';

    strcpy(pseudo, "Guest");

    strcpy(me->p_name, pseudo);
    me->p_team=ALLTEAM;
    getname();
    strcpy(pseudo, me->p_name);
    strcpy(start_name, me->p_name); /* change 1/25/91 TC */

    keeppeace = (me->p_stats.st_flags / ST_KEEPPEACE) & 1;
/*    showgalactic = 1 + (me->p_stats.st_flags / ST_GALFREQUENT) & 1;*/

    /* Set p_hostile to hostile, so if keeppeace is on, the guy starts off
       hating everyone (like a good fighter should) */
    me->p_hostile = (FED|ROM|KLI|ORI);

    s_type = CRUISER;
    me->p_planets=0;
    me->p_genoplanets=0;
    me->p_armsbomb=0;
    me->p_genoarmsbomb=0;
    /* Set up a reasonable default */
    me->p_whydead=KQUIT;

    (void) strncpy(me->p_login, login, sizeof (me->p_login));
    me->p_login[sizeof(me->p_login) - 1] = '\0';
    strcpy(start_login, login); /* change 1/25/91 TC */
    {
	int i;
	for (i = 0; i < MAXPLAYER; i++) ignored[i] = 0;
    }

    (void) strncpy(me->p_monitor, host, sizeof(me->p_monitor));
    me->p_monitor[sizeof(me->p_monitor) - 1] = '\0';

#ifdef FULL_HOSTNAMES
    /* assume this is only place p_monitor is set, and mirror accordingly */
    /* 4/13/92 TC */
    (void) strncpy(me->p_full_hostname, host, sizeof(me->p_full_hostname));
    me->p_full_hostname[sizeof(me->p_full_hostname) - 1] = '\0';
#endif

    logEntry(); /* moved down to get login/monitor 2/12/92 TMC */

    startTkills = me->p_stats.st_tkills;
    startTlosses = me->p_stats.st_tlosses;
    startTarms = me->p_stats.st_tarmsbomb;
    startTplanets = me->p_stats.st_tplanets;
    startTticks = me->p_stats.st_tticks;

    setjmp(env);		/* Reentry point of game */
	/* give the player the motd and find out which team he wants */
    if (me->p_status != PALIVE) {
	me->p_x= -100000;
	me->p_y= -100000;
	updateSelf();
	updateShips();
	teamPick= -1;
	flushSockBuf();
	getEntry(&team, &s_type);
	repCount=0;		/* Make sure he gets an update immediately */
    }
    if (goAway) {		/* change 4/14/91 TC */
	printStats();
	exit(0);
    }
    if (team == -1) {
	exitGame();
    }
    if (indie) team = 4;	/* force to independent 8/28/91 TC */
    redrawall = 1;
    inputMask= -1;	/* Allow all input now */
    enter(team, 0, pno, s_type);
    /*
    for (i = 0; i < NSIG; i++) {
	signal(i, SIG_IGN);
    }
    */

    me->p_status = PALIVE;			/* Put player in game */
    me->p_ghostbuster = 0;

    /* Get input until the player quits or dies */
    input();
}

exitGame()
{
    char buf[80];
    char addrbuf[20];

    if (me != NULL && me->p_team != ALLTEAM) {
#ifndef FULL_HOSTNAMES
	/* old-style leaving message 4/13/92 TC */
	sprintf(buf, "%s %s (%s) leaving the game (%.16s@%.16s)", 
	    ranks[me->p_stats.st_rank].name,
	    me->p_name,
	    me->p_mapchars, 
	    me->p_login,
	    me->p_monitor);
#else
	/* new-style leaving message 4/13/92 TC */
	sprintf(buf, "%s %s (%s) leaving game (%.16s@%.32s)", 
	    ranks[me->p_stats.st_rank].name,
	    me->p_name,
	    me->p_mapchars, 
	    me->p_login,
	    me->p_full_hostname);
#endif
        sprintf(addrbuf, " %c%c->ALL",
	   teamlet[me->p_team], shipnos[me->p_no]);
	pmessage2(buf, 0, MALL | MLEAVE, addrbuf, me->p_no);
	me->p_stats.st_flags &= ~ST_CYBORG; /* clear this flag 8/27/91 TC */
	savestats();
	printStats();
    }
    me->p_status = PFREE;
    exit(0);
}
    

printUsage(prog)
	char	*prog;
{
	printf("Usage: %s [-u] -s socket# machine\n",
		prog);
}

sendMotd()
{
    FILE *motd;
    char buf[100];	/* big enough... */
    int length;

    long curtime;
    struct tm *tmstruct;
    int hour;
    
    time(&curtime);
    tmstruct = localtime(&curtime);
    if (!(hour = tmstruct->tm_hour%12)) hour = 12;
    sprintf(buf,"Connection to server established at %d:%02d%s.", hour,
	    tmstruct->tm_min,
	    tmstruct->tm_hour >= 12 ? "pm" : "am");
    if (!time_access())
	strcat(buf, "  WE'RE CLOSED.  SEE HOURS BELOW.");
    sendMotdLine(buf);
    sendMotdLine(" ");
    
    /* the following will read a motd */
    if ((motd = fopen(MOTD, "r")) != NULL) {
	while (fgets(buf, sizeof (buf), motd) != NULL) {
	    buf[strlen(buf)-1] = '\0';
	    sendMotdLine(buf);
	}
	(void) fclose(motd);
    }
}

reaper(sig)
{
    while (wait3((union wait *) 0, WNOHANG, (struct rusage *) 0) > 0)
	;
}

printStats()
{
    int i;
    FILE *logfile;
    int curtime;

    logfile=fopen(LOGFILENAME, "a");
    if (!logfile) return;
    curtime=time(NULL);
    fprintf(logfile, "Leaving: %-16s (%c%c) %3dP %3dA %3dW/%3dL %3dmin %2d <%s@%s> %s", 
	    me->p_name, 
	    teamlet[me->p_team],
	    shipnos[me->p_no],
	    me->p_stats.st_tplanets - startTplanets,
	    me->p_stats.st_tarmsbomb - startTarms,
	    me->p_stats.st_tkills - startTkills,
	    me->p_stats.st_tlosses - startTlosses,
	    (me->p_stats.st_tticks - startTticks)/600,
	    numPlanets(me->p_team),
	    me->p_login,
#ifndef FULL_HOSTNAMES
	    me->p_monitor,
#else
	    me->p_full_hostname,
#endif
	    ctime(&curtime));
    if (goAway)
	fprintf(logfile, "^^^ 2 players/1 slot.  was %s (%s)\n",
		start_name, start_login);
    fclose(logfile);
}
