/* puck.c
 */
#include "copyright.h"

#include <X11/Xlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <signal.h>
#include <setjmp.h>
#include "defs.h"
#include "struct.h"
#include "data.h"

Window mapw;				/* XXX */

struct itimerval udt;
extern int redrawall;
extern int lastm;

/* lots of neat flags */
int hostile;
int debug;
int oldmctl;			/* was "level", for monitoring messages */
int fleet = 1;
int sticky;
int berserk;
int practice;			/* don't interfere with live game */
int nofuel;
int polymorphic;		/* match opponent's ship class 8/15/91 TC */
int length = 999;		/* unlimited length */
struct planet *oldplanets;	/* for restoring galaxy */

int target;			/* Terminator's target 7/27/91 TC */
int phrange;			/* phaser range 7/31/91 TC */
int trrange;			/* tractor range 8/2/91 TC */

/* velocities 8/9/91 TC */

int dogslow;			/* dodge speed (hard turn) */
int dogfast;			/* dodge speed (soft turn) */
int runslow;			/* run speed (flat etemp) */
int runfast;			/* run speed (gain etemp) */
int closeslow;			/* approach speed (hard turn) */
int closefast;			/* approach speed (soft turn) */

int cleanup();

main(argc, argv)
int argc;
char **argv;
{
    register int i;
    int rmove();
    int team = -1;
    int bteam;
    int pno;
    char str[80];
    int class;			/* ship class 8/9/91 TC */
    
    class = STARBASE;
    target = -1;		/* no target 7/27/91 TC */
    for( ; argc>1 && argv[1][0]=='-'; argc--,argv++) {
	switch(argv[1][1]) {
	  case 'F':
	    nofuel++;
	    break;
	  case 'P':
	    polymorphic++;
	    break;
	  case 'f':
	    fleet++;
	    break;
	  case 's':
	    sticky++;
	    break;
	  case 'd':
	    debug++;
	    break;
	  case 'h':
	    hostile++;
	    break;
	  case 'p':
	    practice++;
	    break;
	  case 'b':
	    berserk++;
	    break;
	  case 'l':		/* length of game */
	    if (argv[1][2] != NULL) {
		length = atoi(&argv[1][2]);
	    } else {
		length = 1;
	    }
	    break;
/*	  case 'T':		/* team */
/*	    switch (argv[1][2]) {
	      case 'f':
		team = 0;
		bteam = FED;
		break;
	      case 'r':
		team = 1;
		bteam = ROM;
		break;
	      case 'k':
		team = 2;
		bteam = KLI;
		break;
	      case 'o':
		team = 3;
		bteam = ORI;
		break;
/*	      case 'n':	/* change 5/10/91 TC neutral */
/*	      case 'i':
		team = 4;
		bteam = FED|ROM|KLI|ORI; /* don't like anybody */
/*		break;
	      case 't': {
		  char c;
		  c = argv[1][3];
		  
		  team = 5;
/*		  bteam = FED|ROM|KLI|ORI; /* don't like anybody */
/*		  target = -1;
		  if (c == '\0') {
		      fprintf(stderr, "Must specify target.  e.g. -Tt3.\n");
		      exit(1);
		  }
		  if ((c >= '0') && (c <= '9'))
		      target = c - '0';
		  else if ((c >= 'a') && (c <= 'j'))
		      target = c - 'a' + 10;
		  else {
		      fprintf(stderr, "Must specify target.  e.g. -Tt3.\n");
		      exit(1);
		  }
/*	      }			/* end case 't' */
/*		break;
/*	      default:
		fprintf(stderr, "Unknown team type.  Usage -Tx where x is [frko]\n");
		exit(1);
	    }			/* end switch argv */
/*	    break;*/
	  default:
	    fprintf(stderr, "Unknown option '%c' (must be one of: bcdfpsFPT)\n", argv[1][1]);
	    exit(1);
	}			/* end switch argv[1][1] */
	
	
    }				/* end for */
    srandom(getpid() * time((long *) 0));
    readsysdefaults();
    openmem();
    pno = findrslot();  /* Robots are entitled to tester's slots. */
    me = &players[pno];
    me->p_no=pno;
    myship = &me->p_ship;
    mystats = &me->p_stats;
    lastm = mctl->mc_current;
    /* At this point we have memory set up.  If we aren't a fleet, we don't
       want to replace any other robots on this team, so we'll check the
       other players and get out if there are any on our team.
    */

    strcpy(pseudo, "Puck");
    strcpy(login, "Robot");

    (void) strncpy(me->p_login, login, sizeof (me->p_login));
    me->p_login[sizeof(me->p_login) - 1] = '\0';
    (void) strncpy(me->p_monitor, "Nowhere", sizeof(me->p_monitor));
    me->p_monitor[sizeof(me->p_monitor) - 1] = '\0';

#ifdef FULL_HOSTNAMES
    /* repeat "Nowhere" for completeness 4/13/92 TC */
    (void) strncpy(me->p_full_hostname, "Nowhere", sizeof(me->p_full_hostname));
    me->p_full_hostname[sizeof(me->p_full_hostname) - 1] = '\0';
#endif

    if (target >= 0)		/* hack 7/27/91 TC */
	enter(team, target, pno, class); /* was BATTLESHIP 8/9/91 TC */
    else
	enter(team, 0, pno, class); /* was BATTLESHIP 8/9/91 TC */

    me->p_pos = -1;			/* So robot stats don't get saved */
    me->p_flags |= PFROBOT;			/* Mark as a robot */

    signal(SIGALRM, rmove);
    if (!debug)
	signal(SIGINT, cleanup);

    oldplanets = (struct planet *) malloc(sizeof(struct planet) * MAXPLANETS);
    bcopy(planets, oldplanets, sizeof(struct planet) * MAXPLANETS);
    config();
    puck_rules();
    udt.it_interval.tv_sec = 0;		/* Robots get to move 2/sec */
    udt.it_interval.tv_usec = 500000;

    udt.it_value.tv_sec = 1;
    udt.it_value.tv_usec = 0;
    if (setitimer(ITIMER_REAL, &udt, 0) < 0) {
	perror("setitimer");
	me->p_status = PFREE;		/* Put robot in game */
	exit(1);
    }
    /* allows robots to be forked by the daemon -- Evil ultrix bullshit */
    sigsetmask(0);

    me->p_status = PALIVE;		/* Put robot in game */
    do_faceoff();
    while (1) {
	pause();
    }
}

findrslot()
{
    register int i;

/*    for (i = 0; i < MAXPLAYER; i++) { */
    for (i = MAXPLAYER-1; i >= 0; i--) {
	/* reverse entry..let's be trendy 4/6/92 TC */
        if (players[i].p_status == PFREE) {     /* We have a free slot */
            players[i].p_status = POUTFIT;      /* possible race code */
            break;
        }
    }
    if ((i == MAXPLAYER) || (i == -1)) {
	if (debug) {
	    fprintf(stderr, "No more room in game\n");
	}
        exit (0);
    }
    bzero(&players[i].p_stats, sizeof(struct stats));  
    players[i].p_stats.st_tticks=1;
    return(i);
}

warning(mess)
int mess;
{
    if (debug)
	fprintf(stderr, "warning: %s\n", mess);
}

config()
{
    int i;

    /* calc class-specific stuff */

    phrange = PHASEDIST * me->p_ship.s_phaserdamage / 100;
    trrange = TRACTDIST * me->p_ship.s_tractrng;

    if (debug) printf("My phaser range: %d.\n", phrange);
    if (debug) printf("My tractor range: %d.\n", trrange);

    myship->s_turns = 2140000000;
    myship->s_accint = 10000;
    myship->s_decint = 10000;
    myship->s_warpcost = 1;
    myship->s_tractstr = 1;
    myship->s_torpdamage = -1;
    myship->s_plasmadamage = -1;
    myship->s_phaserdamage = -1;
    me->p_hostile = 0;
    me->p_swar = 0;
    me->p_team = 0;	/* indep */
/*    myship->s_type = STARBASE;*/
    myship->s_type = SCOUT;
    myship->s_mass = 200;
    myship->s_repair = 30000;
    myship->s_maxspeed = 30;
    myship->s_wpncoolrate = 100;
    myship->s_egncoolrate = 100;
    myship->s_maxwpntemp = 10000;
    myship->s_maxegntemp = 10000;
    oldmctl = mctl->mc_current;	/* start watching messages */

    if (practice) return;	/* don't change galaxy */
    /* align planets */

#define IND 0

#define RINK_TOP 0
#define RINK_BOTTOM GWIDTH
#define TENTH ((RINK_BOTTOM - RINK_TOP)/10)
#define R_MID ((RINK_BOTTOM - RINK_TOP)/2) /* center (red) line */
#define RINK_LENGTH (RINK_BOTTOM - RINK_TOP)

#define RINK_WIDTH (GWIDTH*2/3)
#define G_MID (GWIDTH/2)	/* center of goal */
#define RINK_LEFT (G_MID-(RINK_WIDTH/2))
#define RINK_RIGHT (G_MID+(RINK_WIDTH/2))

#define G_LFT (R_MID-TENTH)	/* left edge of goal */
#define G_RGT (R_MID+TENTH)	/* right edge of goal */
#define RED_1 (RINK_LEFT + (1*RINK_WIDTH/5))
#define RED_2 (RINK_LEFT + (2*RINK_WIDTH/5))
#define RED_3 (RINK_LEFT + (3*RINK_WIDTH/5))
#define RED_4 (RINK_LEFT + (4*RINK_WIDTH/5))

#define ORI_G (RINK_BOTTOM - /*2* */TENTH) /* Ori goal line */
#define ORI_E (RINK_BOTTOM -   TENTH/2) /* end of Ori goal */
#define ORI_B (RINK_BOTTOM - (RINK_LENGTH/3)) /* Ori blue line */
#define KLI_G (RINK_TOP    + /*2* */TENTH) /* Kli goal line */
#define KLI_E (RINK_TOP    +   TENTH/2) /* end of Kli goal */
#define KLI_B (RINK_TOP    + (RINK_LENGTH/3)) /* Kli blue line */

    /* 31 = Cas, 33 = Spi,	            Ori goal line
       35 = Pol, 36 = Arc, 39 = Ant         end of Ori goal */

planets[31].pl_owner = ORI; planets[31].pl_x = G_RGT; planets[31].pl_y = ORI_G;
planets[33].pl_owner = ORI; planets[33].pl_x = G_LFT; planets[33].pl_y = ORI_G;
planets[35].pl_owner = ORI; planets[35].pl_x = G_LFT; planets[35].pl_y = ORI_E;
planets[36].pl_owner = ORI; planets[36].pl_x = G_MID; planets[36].pl_y = ORI_E;
planets[39].pl_owner = ORI; planets[39].pl_x = G_RGT; planets[39].pl_y = ORI_E;

/* 26 = Sco, 25 = Lyr,                Kli goal
   22 = And, 28 = Sco, 24 = Pol,      end of Kli goal */

planets[26].pl_owner = KLI; planets[26].pl_x = G_LFT; planets[26].pl_y = KLI_G;
planets[25].pl_owner = KLI; planets[25].pl_x = G_RGT; planets[25].pl_y = KLI_G;
planets[22].pl_owner = KLI; planets[22].pl_x = G_LFT; planets[22].pl_y = KLI_E;
planets[28].pl_owner = KLI; planets[28].pl_x = G_MID; planets[28].pl_y = KLI_E;
planets[24].pl_owner = KLI; planets[24].pl_x = G_RGT; planets[24].pl_y = KLI_E;

    /* 34 = Pro, 21 = Pliedes V, 32 = El, 27 = Mir      red line */

planets[34].pl_owner = IND; planets[34].pl_x = RED_1; planets[34].pl_y = R_MID;
planets[21].pl_owner = IND; planets[21].pl_x = RED_2; planets[21].pl_y = R_MID;
planets[32].pl_owner = IND; planets[32].pl_x = RED_3; planets[32].pl_y = R_MID;
planets[27].pl_owner = IND; planets[27].pl_x = RED_4; planets[27].pl_y = R_MID;

    /* 23 = Lal, 20 = Kli, 29 = Cas     Kli blue line */
    /* 37 = Urs, 30 = Ori, 38 = Her     Ori blue line */

planets[23].pl_owner = IND; planets[23].pl_x = RED_1; planets[23].pl_y = KLI_B;
planets[20].pl_owner = KLI; planets[20].pl_x = R_MID; planets[20].pl_y = KLI_B;
planets[29].pl_owner = IND; planets[29].pl_x = RED_4; planets[29].pl_y = KLI_B;

planets[37].pl_owner = IND; planets[37].pl_x = RED_1; planets[37].pl_y = ORI_B;
planets[30].pl_owner = ORI; planets[30].pl_x = R_MID; planets[30].pl_y = ORI_B;
planets[38].pl_owner = IND; planets[38].pl_x = RED_4; planets[38].pl_y = ORI_B;

    planets[0].pl_couptime = 999999; /* no Feds */
    planets[10].pl_couptime = 999999; /* no Roms */
    for (i=0; i<10; i++) {
	planets[i].pl_owner = IND;
	planets[i].pl_x = RINK_LEFT;
	planets[i].pl_y = RINK_TOP+ i * TENTH + TENTH/2;
	planets[i+10].pl_owner = IND;
	planets[i+10].pl_x = RINK_RIGHT;
	planets[i+10].pl_y = RINK_TOP+ i * TENTH + TENTH/2;
	planets[i+00].pl_flags |= (PLFUEL | PLREPAIR);
	planets[i+10].pl_flags |= (PLFUEL | PLREPAIR);
	planets[i+20].pl_flags |= (PLFUEL | PLREPAIR);
	planets[i+30].pl_flags |= (PLFUEL | PLREPAIR);

	planets[i+00].pl_info |= ALLTEAM;
	planets[i+10].pl_info |= ALLTEAM;
	planets[i+20].pl_info |= ALLTEAM;
	planets[i+30].pl_info |= ALLTEAM;
    }
}
