/* rmove.c
 */
#include "copyright.h"

#include <X11/Xlib.h>
#include <stdio.h>
#include <signal.h>
#include <math.h>
#include "defs.h"
#include "struct.h"
#include "data.h"

/* #define SOCCER_SHOOT define this for soccer-style shooting */
#define WEAKER_STR 2		/* integer factor to divide tractstr down */
#define WEAKER_RNG 1.25		/* factor to divide tractrng down */

#define SIZEOF(s)		(sizeof (s) / sizeof (*(s)))
#define AVOID_TIME		4
#define AVOID_CLICKS		200

/* copied from puck.c */
#define RINK_TOP 0
#define RINK_BOTTOM GWIDTH
#define TENTH ((RINK_BOTTOM - RINK_TOP)/10)
#define R_MID ((RINK_BOTTOM - RINK_TOP)/2) /* center (red) line */
#define RINK_LENGTH (RINK_BOTTOM - RINK_TOP)

#define RINK_WIDTH (GWIDTH*2/3)
#define G_MID (GWIDTH/2)	/* center of goal */
#define RINK_LEFT (G_MID-(RINK_WIDTH/2))
#define RINK_RIGHT (G_MID+(RINK_WIDTH/2))

#define G_LFT (R_MID-TENTH)	/* left edge of goal */
#define G_RGT (R_MID+TENTH)	/* right edge of goal */
#define RED_1 (RINK_LEFT + (1*RINK_WIDTH/5))
#define RED_2 (RINK_LEFT + (2*RINK_WIDTH/5))
#define RED_3 (RINK_LEFT + (3*RINK_WIDTH/5))
#define RED_4 (RINK_LEFT + (4*RINK_WIDTH/5))

#define ORI_G (RINK_BOTTOM - /*2* */TENTH) /* Ori goal line */
#define ORI_E (RINK_BOTTOM -   TENTH/2) /* end of Ori goal */
#define ORI_B (RINK_BOTTOM - (RINK_LENGTH/3)) /* Ori blue line */
#define KLI_G (RINK_TOP    +/* 2* */ TENTH) /* Kli goal line */
#define KLI_E (RINK_TOP    +   TENTH/2) /* end of Kli goal */
#define KLI_B (RINK_TOP    + (RINK_LENGTH/3)) /* Kli blue line */

#define NORMALIZE(d) 		(((d) + 256) % 256)

#define E_INTRUDER	0x01
#define E_TSHOT		0x02
#define E_PSHOT 	0x04
#define E_TRACT 	0x08
#define NOENEMY (struct Enemy *) -1

struct Enemy {
    int e_info;
    int e_dist;
    unsigned char e_course;	/* course to enemy */
    unsigned char e_edir;	/* enemy's current heading */
    unsigned char e_tcourse;	/* torpedo intercept course to enemy */
    unsigned int e_flags;
    int e_tractor;		/* who he's tractoring/pressoring */
    int e_phrange;		/* his phaser range */
    int e_trrange;		/* his tractor range */
    struct player *pstruct;
};

typedef struct Track {		/* our record of this player */
    int t_x;
    int t_y;
    int t_status;
    unsigned int t_goals;
    unsigned int t_assists;
    unsigned int t_seconds;
} Track;

Track tracks[MAXPLAYER];

static int avoidTime;

/* puck junk */
/* hard coding ori vs klis */

#define END_OF_PERIOD 20*60*2
#define PERIODS_PER_GAME 3
#define FACEOFF 40*2
#define DEFLECT_DIST 750
#define SHOTRANGE 3000
#define SHOTSPEED 40
#define SHOOTABLE_FACTOR 3
#define DISPLACE 5000
#define OFFSET 10000

int scores[MAXTEAM+1];
int currp[MAXTEAM+1];
int lastp[MAXTEAM+1];
int faceoff = FACEOFF;		/* "faceoff" mode */
int period = 1;
int clock = 0;

#define MESSFUSEVAL 100
static int messfuse = MESSFUSEVAL;
static char rmessage[110];
static char tmessage[110];

char* puckie_messages[] = {
    "Look at $n work that biscuit!",
    "Can $n shoot his way out of a paper bag?",
    "$n has the puck at $w.",
    "$n takes possession for the $ts at $w.",
    "This rink isn't big enough for the two of us, $n.",
    "The $ts are considering trading away $n.",
    "$n is actually the $t mascot.",
    "Look out, $n is racing by $w.",
    "$n is looking tired.",
    "Attention $t shoppers, Blue Light special at $w.",
    "$n shows off some impressive stickwork at $w.",
    "$n slices through $w!",
    "$n takes command of the puck.",
    "$n has turned in an impressive performance tonight.",
    "You know, the $ts should have retired $n ages ago.",
    "$n weaves through traffic...",
};

extern int debug;
extern int oldmctl;
extern int hostile;
extern int sticky;
extern int practice;
extern int polymorphic;

extern int target;		/* robotII.c 7/27/91 TC */
extern int phrange;		/* robotII.c 7/31/91 TC */
extern int trrange;		/* robotII.c 8/2/91 TC */

extern int length;
extern struct planet *oldplanets;

unsigned char	getcourse();
char *robo_message();
char *puckie_message();		/* added 8/2/91 TC */

rmove()
{
    register struct player *j;
    register int i;
    register int burst;
    register int numHits, tDir;
    int		avDir;
    extern struct Enemy *get_nearest();
    struct Enemy *enemy_buf;
    struct player *enemy;
    static int	avoid[2] = { -32, 32 };
    int no_cloak;
    char towhom[80];
    int timer;
    static int lastTorpped = 0; /* when we last fired a torp 4/13/92 TC */
    static int lastx;
    static int lasty;

    static int shotage;
    static int shotby;

    clock++;			/* time in 0.5 sec intervals */
    if (clock == END_OF_PERIOD) {
        if (period == PERIODS_PER_GAME) {
	    messAll("#############################");
	    messAll("#");
	    messAll("#  END OF GAME.");
	    messAll("#");
	} else {
	    messAll("#");
	    messAll("#  END OF PERIOD.");
	    messAll("#");
	    woomp();
	}
	do_score();
	clock = 0;
	me->p_ship.s_type = STARBASE;
	me->p_whydead=KPLASMA;
	me->p_explode=10;
	me->p_status=3;
	me->p_whodead=0;
	if (period == PERIODS_PER_GAME) {
	    if (scores[KLI] > scores[ORI]) messAll("# Klingons win!");
	    else if (scores[ORI] > scores[KLI]) messAll("# Orions win!");
	    else messAll("# Tie game!");
	    messAll("#############################");
	    scores[ORI] = 0;
	    scores[KLI] = 0;
	    period = 0;
	    length--;
	    if (length == 0)
		cleanup();
	    do_score();
	}
	period++;
    }
    /* Check that I'm alive */
    if (me->p_status == PEXPLODE) {
	if (debug) fprintf(stderr,"Robot: Augh! exploding.\n");
	return;
    }
    if (me->p_status != PALIVE) {
	if (me->p_whydead == KPLASMA) /* assume due to goal scored */ {
	    me->p_status = PALIVE;
	    me->p_ship.s_type = SCOUT;
	    do_faceoff();
	}
	else
	    exitRobot();
    }

    /* keep ghostbuster away */
    me->p_ghostbuster = 0;

    if ((clock % 10) == 0) do_msg_check();

    /* first priority:  is this faceoff mode?  */
    
    if (faceoff > 0) {
	char buf[80];
	faceoff--;
	if (faceoff == 0) {
	    int i;
	    do_war();		/* open hostilities */
	    do_offsides();
	    for (i = 0; i <= MAXTEAM; i++) {
		currp[i] = -1; lastp[i] = -1;
	    }
	    messAll("<thunk!>");
	    me->p_x = 45000 + random()%10000; /* reappear */
	    me->p_y = 50000;
	    lasty = 50000;	/* avoid boing problems */
	    shotby = -1;	/* to find winner of faceoff */
	}
	else if ((faceoff % 20) == 0) {
	    /* maintain peace */
	    do_peace();
	    sprintf(buf,"Faceoff in %d seconds.", faceoff/2);
	    messAll(buf);
	    if (faceoff == FACEOFF-20) { /* move everybody home */
		do_teleport_home();
	    }
	}
	return;
    }

    /* second priority:  did we enter a goal? */

    if ((me->p_y < KLI_G) && (me->p_x > G_LFT) && (me->p_x < G_RGT)
	&& lasty >= KLI_G) {
	    do_goal(ORI, clock);
	    return;
    }
    if ((me->p_y > ORI_G) && (me->p_x > G_LFT) && (me->p_x < G_RGT)
	&& lasty <= ORI_G) {
	do_goal(KLI, clock);
	return;
    }

    /* do left/right bounce */

    if (me->p_x < RINK_LEFT) {
	me->p_x = RINK_LEFT + (RINK_LEFT - me->p_x);
	me->p_dir = me->p_desdir = 64 - (me->p_dir - 192);
    } else if (me->p_x > RINK_RIGHT) {
	me->p_x = RINK_RIGHT - (me->p_x - RINK_RIGHT);
	me->p_dir = me->p_desdir = 192 - (me->p_dir - 64);
    }

    /* do goal bounce? */

    if (((me->p_y > ORI_G) && (me->p_y < ORI_E)) ||
	((me->p_y < KLI_G) && (me->p_y > KLI_E))) {
	if ((me->p_x < G_RGT) && (lastx > G_RGT)) {
	    if (me->p_speed > 0)
		messAll("Boing!  Off right side of goal.");
	    me->p_x = G_RGT + (G_RGT - me->p_x);
	    me->p_dir = me->p_desdir = 64 - (me->p_dir - 192);
	} else if ((me->p_x > G_LFT) && (lastx < G_LFT)) {
	    if (me->p_speed > 0)
		messAll("Boing!  Off left side of goal.");
	    me->p_x = G_LFT - (me->p_x - G_LFT);
	    me->p_dir = me->p_desdir = 192 - (me->p_dir - 64);
	}
    }
    if ((me->p_x > G_LFT) && (me->p_x < G_RGT)) {
	if ((me->p_y > KLI_E) && (lasty < KLI_E)) {
	    if (me->p_speed > 0)
		messAll("Boing!  Off back of Kli goal.");
	    me->p_dir = me->p_desdir = 0 - (me->p_dir - 128);
	    me->p_y = KLI_E - (me->p_y - KLI_E); 
	} else if ((me->p_y < ORI_E) && (lasty > ORI_E)) {
	    if (me->p_speed > 0)
		messAll("Boing!  Off back of Ori goal.");
	    me->p_dir = me->p_desdir = 128 - me->p_dir; 
	    me->p_y = ORI_E + (ORI_E - me->p_y);
	}
    }

    lastx = me->p_x;
    lasty = me->p_y;

    if ((clock % 20) == 0) do_war();
    if ((clock % 240) == 0) {
	puck_rules();
	do_score();
    }
    
    /* inertia:  slow down */

    if (me->p_desspeed > 0) {
	me->p_desspeed = ((float)SHOTSPEED) * (1.0/((float)(clock-shotage)/3.5+1.0));
	me->p_speed = me->p_desspeed;
    }
    
    /* shots: track possession, check for close pressorers */
    
    enemy_buf = get_nearest();
    if ((enemy_buf == NULL) || (enemy_buf == NOENEMY)) return;

    if (isInPossession(enemy_buf)) {

	/* random commentary */

	if ((random() % messfuse) == 0) {
	    messAll(puckie_message(enemy_buf->pstruct));
	    messfuse = MESSFUSEVAL;
	} else
	    if (--messfuse == 0)
		messfuse = 1;

	/* intercepts/deflects -- stop moving puck/change dir randomly */

	if (currp[enemy_buf->pstruct->p_team] != enemy_buf->e_info) {
	    /* new guy in possession */
	    lastp[enemy_buf->pstruct->p_team] = currp[enemy_buf->pstruct->p_team];
	    currp[enemy_buf->pstruct->p_team] = enemy_buf->e_info;
	}
	if (me->p_desspeed < SHOTSPEED/SHOOTABLE_FACTOR)
	    me->p_desspeed = 0;
	else {			/* deflections */
	    if ((enemy_buf->e_dist < DEFLECT_DIST) &&
		(angdist(enemy_buf->e_course, me->p_dir) < 64)) {
		static char buf[80];
		sprintf(buf,"    Deflected by %s (%2s)!",
			enemy_buf->pstruct->p_name,
			enemy_buf->pstruct->p_mapchars);
		messAll(buf);
		me->p_desdir = me->p_desdir + random() % 192 - 96;
		me->p_dir = me->p_desdir;
	    }
	}
    }

    if ((enemy_buf->e_dist < SHOTRANGE) &&
	(me->p_desspeed < SHOTSPEED/SHOOTABLE_FACTOR)) { /* shootable */
	
	static char buf[80];
	if (isPressoringMe(enemy_buf)) {
	    if (shotby == -1)
		sprintf(buf,"    %s (%2s) wins the faceoff.", enemy_buf->pstruct->p_name,
			enemy_buf->pstruct->p_mapchars);
	    else
		sprintf(buf,"    %s (%2s) shoots!", enemy_buf->pstruct->p_name,
			enemy_buf->pstruct->p_mapchars);
	    messAll(buf);
	    enemy_buf->pstruct->p_flags &= ~PFTRACT;
	    enemy_buf->pstruct->p_flags &= ~PFPRESS;
	    shotage = clock;
	    shotby = enemy_buf->e_info;
	    me->p_desspeed = SHOTSPEED;
	    me->p_speed = SHOTSPEED;
#ifdef SOCCER_SHOOT
	    me->p_dir = enemy_buf->e_course + 128;
	    me->p_desdir = enemy_buf->e_course + 128 ;
#else
	    me->p_dir = enemy_buf->pstruct->p_dir;
	    me->p_desdir = enemy_buf->pstruct->p_dir;
#endif
	} else {		/* no shot yet */
	    if (enemy_buf->e_trrange > enemy_buf->e_dist)
		me->p_flags |= PFSHIELD; /* shield up */
	    else
		me->p_flags &= ~PFSHIELD;
	}			/* end shot */
    } else {		/* not shootable */
	me->p_flags &= ~PFSHIELD; /* shield down */
    }			/* end shootable */
}

cleanup()
{
    register struct player *j;
    register int i;

    if (!practice) {
	bcopy(oldplanets, planets, sizeof(struct planet) * MAXPLANETS);
	for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++) {
	    if ((j->p_status != PALIVE) || (j == me)) continue;
	    getship(&(j->p_ship), j->p_ship.s_type, j->p_team);
	}
    }
    exitRobot();
}

do_teleport_home()
{
    register int i;
    register struct player *j;
    int startplanet;

    if (practice) return;
    for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++) {
	if ((j->p_status != PALIVE) || (j == me)) continue;
	if (j->p_team == KLI)
	    startplanet = 20;
	else if (j->p_team == ORI)
	    startplanet = 30;
	else
	    continue;
	j->p_flags = PFSHIELD;
	if (((j->p_team == KLI) && (j->p_y > GWIDTH/2)) ||
	    ((j->p_team == ORI) && (j->p_y < GWIDTH/2))) { /* relocate only if offsides */
	    j->p_y = planets[startplanet].pl_y + (random() % (2*DISPLACE) - DISPLACE);
	    j->p_speed = 0;
	    j->p_desspeed = 0;
	    j->p_subspeed = 0;
	}
	j->p_fuel = j->p_ship.s_maxfuel;
	j->p_shield = j->p_ship.s_maxshield;
	j->p_damage = 0;
    }
}

do_peace()
{
    register int i;
    register struct player *j;

    if (practice) return;
    for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++) {
	j->p_hostile = 0;
	j->p_swar = 0;
	j->p_ship.s_tractstr = 1;
    }
}

do_msg_check()
{
    while (oldmctl!=mctl->mc_current) {
	oldmctl++;
	if (oldmctl==50) oldmctl=0;
	if (messages[oldmctl].m_flags & MINDIV) {
	    if (messages[oldmctl].m_recpt == me->p_no) {
		if (strstr(messages[oldmctl].m_data, "help") != NULL)
		    do_help(messages[oldmctl].m_from);
		if (strstr(messages[oldmctl].m_data, "score") != NULL)
		    do_score_msg(messages[oldmctl].m_from);
		if (strstr(messages[oldmctl].m_data, "stats") != NULL)
		    do_stats_msg(messages[oldmctl].m_from);
	    }
	} else if (messages[oldmctl].m_flags & MALL) {
	    if (strstr(messages[oldmctl].m_data, "help") != NULL)
		messOne("If you want help from me, send me the message 'help'.", 
			messages[oldmctl].m_from);		
	}
    }
}

do_help(who)
int who;
{
    messOne("This is Netrek hockey.  Push me into the opposition's goal to score.", who);
    messOne("Goal lines are Sco/Lyr and Spi/Cas. No t-mode, no bombing/beaming.", who);
    messOne("After exploding, ship appears where it died +/- random x offset.", who);
#ifdef SOCCER_SHOOT
    messOne("To shoot: Be nearest to me and pressor. Shot goes in dir of pressor.", who);
#else
    messOne("To shoot: Be nearest to me and pressor. Shot dir is your ship's dir.", who);
#endif
    messOne("My shields go up if I'm shootable.  Easiest to shoot at low warp.", who);
    messOne("Shots can be blocked by tractoring/pressoring a shot puck.  No etmp.", who);
    messOne("Send me 'score' or 'stats' for game info.", who);
}

do_stats_msg(who)
int who;
{
    char buf[80];
    register int i;
    register Track *track;
    register struct player *j;
    for (i = 0, j = &players[i], track = &tracks[i];
	 i < MAXPLAYER; i++, j++, track++) {
	if ((j->p_status != PFREE) && !(j->p_flags & PFROBOT)) {
	    sprintf(buf, " %2s: %-16s  %2dG %2dA %3d min",
		    j->p_mapchars,
		    j->p_name,
		    track->t_goals,
		    track->t_assists,
		    track->t_seconds / 60);
	    messOne(buf, who);
	}
    }
}

do_war()
{
    register int i;
    register struct player *j;

    if (practice) return;
    for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++) {
	if ((j->p_status == PALIVE) && (j != me)) {
	    tracks[i].t_seconds += 10;
	    j->p_hostile |= (KLI|ORI);
	    j->p_hostile &= ~j->p_team;
	    j->p_armies = 0;
	    j->p_ship.s_egncoolrate = 12;
/*	    j->p_ship.s_tractstr = 2500; non-uniform tractor str? */
	    switch (j->p_ship.s_type) {
	      case SCOUT:
		j->p_ship.s_tractstr = 2000/WEAKER_STR; /* scout:  */
                j->p_ship.s_tractrng = 0.7/WEAKER_RNG;
		break;
	      case DESTROYER:
		j->p_ship.s_tractstr = 2500/WEAKER_STR; /* destroyer: */
                j->p_ship.s_tractrng = 0.9/WEAKER_RNG;
		break;
	      case BATTLESHIP:
		j->p_ship.s_tractstr = 3700/WEAKER_STR; /* battleship: */
                j->p_ship.s_tractrng = 1.2/WEAKER_RNG;
		break;
	      case ASSAULT:
		j->p_ship.s_tractstr = 2500/WEAKER_STR; /* assault */
                j->p_ship.s_tractrng = 0.7/WEAKER_RNG;
		break;
	      case STARBASE:
		j->p_ship.s_tractstr = 8000/WEAKER_STR; /* starbase */
                j->p_ship.s_tractrng = 1.5/WEAKER_RNG;
		break;
	      case ATT:
		j->p_ship.s_tractstr = 32765/WEAKER_STR; /* att: */
		break;
	      default:
		j->p_ship.s_tractstr = 3000/WEAKER_STR; /* cruiser: */
                j->p_ship.s_tractrng = 1.0/WEAKER_RNG;
		break;

	    }
/*	    j->p_ship.s_tractrng = 0.9;*/
	}
    }
}

do_offsides()
{
    static char buf[80];
    register int i;
    register struct player *j;

    if (practice) return;
    for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++) {
	if ((j != me) && (j->p_status == PALIVE)) {
	    if (((j->p_team == KLI) && (j->p_y > GWIDTH/2)) ||
		((j->p_team == ORI) && (j->p_y < GWIDTH/2))) {
		int startplanet;
		sprintf(buf, "%s (%2s) is offsides.", j->p_name,
			j->p_mapchars);
		messAll(buf);
		if (j->p_team == KLI)
		    startplanet = 20;
		else if (j->p_team == ORI)
		    startplanet = 30;
		j->p_y = planets[startplanet].pl_y + (random() % (2*DISPLACE) - DISPLACE);
	    }
	}
    }
}


puck_rules()
{
    messAll("This is Netrek hockey.  Send me the message \"help\" for rules.");
}

char* team_names[MAXTEAM+1] = { "", "Federation", "Romulans", "", "Klingons",
				   "", "", "", "Orions" };
do_goal(team)
int team;
{
    char buf[80];
    messAll("*****************************************************************");

    if (lastp[team] == -1) {	/* unassisted */
	if (currp[team] == -1) { /* untouched?! */
	    sprintf(buf, "* The %s score without touching the puck!?",
		    team_names[team]);
	} else {
	    sprintf(buf, "* %s scores for the %s!  Unassisted!",
		    players[currp[team]].p_name, team_names[team]);
	    tracks[currp[team]].t_goals++;
	}
    } else {
	sprintf(buf, "* %s scores for the %s!  %s assisting!",
		players[currp[team]].p_name, team_names[team],
		players[lastp[team]].p_name);
	tracks[currp[team]].t_goals++;
	tracks[lastp[team]].t_assists++;
    }
    messAll(buf);
    switch (random()%10) {
      case 0:
	messAll("* Get in the fast lane, Gramma, the bingo game is ready to roll!"); break;
      case 1:
	messAll("* Scratch my back with hacksaw!"); break;
      case 2:
	messAll("* He beat him like a rented mule!"); break;
      case 3:
	messAll("* Book'em Danno!"); break;
      case 4:
	messAll("* She wants to sell my monkey!"); break;
      case 5:
	messAll("* Ladies and gentlemen, Elvis has just left the building!"); break;
      case 6:
	messAll("* Look out Loretta!"); break;
      case 7:
	messAll("* How now Eddie Spaghetti!"); break;
      case 8:
	messAll("* Michael Michael motorcycle!"); break;
      case 9:
	messAll("* Stop the press, it's over now!"); break;
    }
    messAll("*****************************************************************");
    scores[team]++;
    do_score();
    me->p_ship.s_type = STARBASE;
    me->p_whydead=KPLASMA;
    me->p_explode=10;
    me->p_status=3;
    me->p_whodead=0;
/*    do_faceoff();*/
}

do_score()
{
    static char buf[80];
    int tempclock;
    tempclock = clock/2;
    sprintf(buf, "Score is Klis %d, Oris %d.  Elapsed time %02d:%02d.  Period %d.",
	    scores[KLI], scores[ORI], tempclock/60, tempclock%60, period);
    messAll(buf);
}

do_score_msg(who)
int who;
{
    static char buf[80];
    int tempclock;
    tempclock = clock/2;
    sprintf(buf, "Score is Klis %d, Oris %d.  Elapsed time %02d:%02d.  Period %d.",
	    scores[KLI], scores[ORI], tempclock/60, tempclock%60, period);
    messOne(buf, who);
}

do_faceoff()
{
    register int i;
    register struct player *j;
    Track *track;
    
    for (i = 0, j = &players[i], track = &tracks[i];
	i < MAXPLAYER; i++, j++, track++) {
	if (j == me)
	    continue;
	track->t_x = 0;
	track->t_y = 0;
    }
    me->p_speed = 0;
    me->p_desspeed = 0;
    me->p_x = -100000;		/* disappear for a bit */
    me->p_y = -100000;
    if (debug)
	faceoff = 5;
    else
	faceoff = FACEOFF;
}
	
unsigned char
getcourse(x, y)
int x, y;
{
	return((unsigned char) (atan2((double) (x - me->p_x),
	    (double) (me->p_y - y)) / 3.14159 * 128.));
}

isInPossession(enemy_buf)
struct Enemy *enemy_buf;
{
    return ((enemy_buf->pstruct->p_flags & PFTRACT) &&
	    (enemy_buf->pstruct->p_tractor == me->p_no));
}

isTractoringMe(enemy_buf)
struct Enemy *enemy_buf;
{
    return ((enemy_buf->pstruct->p_flags & PFTRACT) &&
	    !(enemy_buf->pstruct->p_flags & PFPRESS) &&
	    (enemy_buf->pstruct->p_tractor == me->p_no));
}

isPressoringMe(enemy_buf)
struct Enemy *enemy_buf;
{
    return ((enemy_buf->pstruct->p_flags & PFTRACT) &&
	    (enemy_buf->pstruct->p_flags & PFPRESS) &&
	    (enemy_buf->pstruct->p_tractor == me->p_no));
}

woomp()
{
    register int i;
    register struct player *j;

    /* avoid dead slots, me, other robots (which aren't hostile) */
    for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++) {
	if (j == me || j->p_status == PFREE)
	    continue;
	j->p_ship.s_type = STARBASE;
	j->p_whydead=KPLASMA;
	j->p_explode=10;
	j->p_status=3;
	j->p_whodead=me->p_no;
    }
}


struct Enemy ebuf;

struct Enemy *
get_nearest()
{
    int pcount = 0;
    register int i;
    register struct player *j;
    Track *track;
    int intruder = 0;
    int tdist;
    double dx, dy;
    double vxa, vya, l;	/* Used for trap shooting */
    double vxt, vyt;
    double vxs, vys;
    double dp;

    /* Find an enemy */
    ebuf.e_info = me->p_no;
    ebuf.e_dist = GWIDTH + 1;

    pcount = 0;  /* number of human players in game */

    /* avoid dead slots, me, other robots (which aren't hostile) */
    for (i = 0, j = &players[i], track = &tracks[i];
	 i < MAXPLAYER; i++, j++, track++) {
	if (j == me)
	    continue;
	else if (j->p_status != PALIVE) {
	    track->t_status = j->p_status;
	    if (j->p_status == PFREE) {
		track->t_goals = 0;
		track->t_assists = 0;
		track->t_seconds = 0;
		track->t_x = 0;
		track->t_y = 0;
	    }
	    continue;		/* do nothing else for dead players */
	}
	
	if ((track->t_status != PALIVE) && (track->t_x != 0)) {
	    if (!practice) {
		if (random() % 2 == 0) /* step to the left */
		    j->p_x = track->t_x - ((random() % DISPLACE) + OFFSET);
		else /* step to the right */
		    j->p_x = track->t_x + ((random() % DISPLACE) + OFFSET);
		/* and shake it all around */
/*		j->p_y = track->t_y + (random() % (2*DISPLACE) - DISPLACE);*/
		j->p_y = track->t_y;
	    }
	}
	track->t_status = j->p_status;
	track->t_x = j->p_x;
	track->t_y = j->p_y;

	pcount++;	/* Other players in the game */
	if ((j->p_flags & PFROBOT) && !practice) { /* kill robots */
	    char buf[80];
	    sprintf(buf, "%s (%2s) was utterly obliterated (no other robots!).", 
		    j->p_name, j->p_mapchars);
	    j->p_ship.s_type = STARBASE;
	    j->p_whydead=KPROVIDENCE;
	    j->p_explode=10;
	    j->p_status=3;
	    j->p_whodead=0;
	    messAll(buf);
	    continue;
	}

	/* We have an enemy */
	/* Get his range */
	dx = j->p_x - me->p_x;
	dy = j->p_y - me->p_y;
	tdist = hypot(dx, dy);
	
	if (tdist < ebuf.e_dist) {
	    ebuf.e_info = i;
	    ebuf.e_dist = tdist;
	    if (intruder)
		ebuf.e_flags |= E_INTRUDER;
	    else
		ebuf.e_flags &= ~(E_INTRUDER);
	}
    }			/* end for */
    if (pcount == 0) {
	return (NOENEMY);    /* no players in game */
    } else if (ebuf.e_info == me->p_no) {
	return (0);			/* no hostile players in the game */
    } else {
	j = &players[ebuf.e_info];
	ebuf.pstruct = j;

	/* Get torpedo course to nearest enemy */
	ebuf.e_flags &= ~(E_TSHOT);

	/* Get phaser shot status */
	if (ebuf.e_dist < 0.8 * phrange)
		ebuf.e_flags |= E_PSHOT;
	else
		ebuf.e_flags &= ~(E_PSHOT);

	/* Get tractor/pressor status */
	if (ebuf.e_dist < trrange)
		ebuf.e_flags |= E_TRACT;
	else
		ebuf.e_flags &= ~(E_TRACT);


	/* get his phaser and tractor range */
	ebuf.e_phrange = PHASEDIST * j->p_ship.s_phaserdamage / 100;
	ebuf.e_trrange = TRACTDIST * j->p_ship.s_tractrng;

	/* get course info */
	ebuf.e_course = getcourse(j->p_x, j->p_y);
	ebuf.e_edir = j->p_dir;
	ebuf.e_tractor = j->p_tractor;
	/*
	if (debug)
	    fprintf(stderr, "Set course to enemy is %d (%d)\n",
		    (int)ebuf.e_course, 
		    (int) ebuf.e_course * 360 / 256);
	*/

	return (&ebuf);
    }
}

pmessage(str, recip, group, address)
char *str;
int recip;
int group;
char *address;
{
    pmessage2(str, recip, group, address, 255);
}

pmessage2(str, recip, group, address, from) 
char *str;
int recip;
int group;
char *address;
unsigned char from;
{
    struct message *cur;
    int mesgnum;

    if ((mesgnum = ++(mctl->mc_current)) >= MAXMESSAGE) {
	mctl->mc_current = 0;
	mesgnum = 0;
    }
    cur = &messages[mesgnum];
    cur->m_no = mesgnum;
    cur->m_flags = group;
    cur->m_recpt = recip;
    cur->m_from = from;
    (void) sprintf(cur->m_data, "%-9s %s", address, str);
    cur->m_flags |= MVALID;
}

char* puckie_message(enemy)
struct player* enemy;
{
    int i;
    char *s,*t;
    
    i=(random() % (sizeof(puckie_messages)/sizeof(puckie_messages[0])));

    for (t=puckie_messages[i], s=tmessage; *t!='\0'; s++, t++) {
	switch(*t) {
	case '$':
	    switch(*(++t)) {
		case '$':
		    *s = *t;
		    break;
		case 'T':    /* "a Fed" or "a Klingon" ... */
		    if (enemy->p_team != me->p_team &&
			enemy->p_team == ORI) {
			strcpy(s, "an ");
		    } else {
			strcpy(s, "a ");
		    }
		    s=s+strlen(s);
		case 't':    /* "Fed" or "Orion" */
                    if (enemy->p_team != me->p_team) {
	                switch (enemy->p_team) {
			  case FED:
	                    strcpy(s, "Fed");
	                    break;
			  case ROM:
	                    strcpy(s, "Romulan");
	                    break;
			  case KLI:
	                    strcpy(s, "Klingon");
	                    break;
			  case ORI:
	                    strcpy(s, "Orion");
	                    break;
	                }
                    } else {
	                strcpy(s, "TRAITOR");
                    }
		    s=s+strlen(s)-1;
		    break;
		  case 'n':	/* name 8/2/91 TC */
		    strcpy(s, enemy->p_name);
		    s=s+strlen(s)-1;
		    break;
		  case 'w':	/* where on the rink */
		    if (me->p_y < KLI_G)
			strcpy(s, "the Klingon goal end");
		    else if (me->p_y < KLI_B)
			strcpy(s, "the Klingon zone");
		    else if (me->p_y < ORI_B)
			strcpy(s, "the neutral zone");
		    else if (me->p_y < ORI_G)
			strcpy(s, "the Orion zone");
		    else
			strcpy(s, "the Orion goal end");
		    s=s+strlen(s)-1;
		    break;
		  default:
		    *s = *t;
	    }
	    break;
	default:
	    *s = *t;
	    break;
	}
    }
    *s='\0';
    return(tmessage);
    
}

exitRobot()
{
    static char buf[80];

    signal(SIGALRM, SIG_IGN);
    if (me != NULL && me->p_team != ALLTEAM) {
	if (target >= 0) {
	    strcpy(buf, "I'll be back.");
	    messAll(buf);
	}
	else {
/*	    sprintf(buf, "%s %s (%s) leaving the game (%.16s@%.16s)", 
		    ranks[me->p_stats.st_rank].name,
		    me->p_name,
		    me->p_mapchars, 
		    me->p_login,
		    me->p_monitor);
	    messAll(buf);*/
	}
    }
    
    /* something about Terminators hangs up the slot when a human */
    /* tries to log in on that slot, so...*/

    bzero(me, sizeof(struct player)); /* confusion 8/5/91 TC */
/*    me->p_status = PFREE;*/

    /* all right, so zeroing out p_stats.st_tticks has undesireable
       side effects when the client tries to compute ratings... */

    me->p_stats.st_tticks = 1; /* quick fix 3/15/92 TC */
    exit(0);
}

messAll(buf)
char *buf; /* wasn't K&R before...oops 5/1/92 TC */
{
    static char addrbuf[20];

    sprintf(addrbuf, "Puck->ALL");
    if (practice)
	printf("%s %s\n", addrbuf, buf);
    else
	pmessage2(buf, 0, MALL, addrbuf, me->p_no);
}

messOne(buf, who)
char *buf; /* wasn't K&R before...oops 5/1/92 TC */
int who;
{
    static char addrbuf[20];

    if (who == me->p_no) return; /* hack: don't message self :) */
    sprintf(addrbuf, "Puck->%s", players[who].p_mapchars);
    pmessage2(buf, who, MINDIV, addrbuf, me->p_no);
}
