static char rcsid[] = "$Header: /usr/users/terence/src/xtrek/ntserv/RCS/sysdefaults.c,v 1.3 92/03/19 21:34:34 terence Exp $";

/* $Log:	sysdefaults.c,v $
 * Revision 1.3  92/03/19  21:34:34  terence
 * Added UDP mods (version 0.2, 3/17/92)
 * 
 * Revision 1.2  92/03/11  15:56:51  terence
 * added UDP mods
 *  */

/* sysdefaults.c
 * 
 * This code is pretty hacked up, but it works fine.
 */
#include <stdio.h>
#include <math.h>
#include <strings.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "copyright2.h"

static struct stat oldstat;

char *shiptypes[NUM_TYPES] = {"SC", "DD", "CA", "BB", "AS", "SB", "??"};
char *weapontypes[WP_MAX] = {"PLASMA", "TRACTOR"};
char *planettypes[MAXPLANETS] = {
    "00", "01", "02", "03", "04", "05", "06", "07", "08", "09",
    "10", "11", "12", "13", "14", "15", "16", "17", "18", "19",
    "20", "21", "22", "23", "24", "25", "26", "27", "28", "29",
    "30", "31", "32", "33", "34", "35", "36", "37", "38", "39" 
};

readsysdefaults()
{
    int i,j;
    FILE *f;
    char buf[200];
    char *s,*t;

    /* Setup defaults. */
    for (i=0; i<MAXPLANETS; i++) {
	startplanets[i]=0;
    }
    startplanets[0]=startplanets[10]=startplanets[20]=startplanets[30]=1;
    for (i=0; i<NUM_TYPES; i++) {
	shipsallowed[i]=1;
    }
    for (i=0; i<WP_MAX; i++) {
	weaponsallowed[i]=1;
    }
    testtime= -1;
    chaos=0;
    topgun=0; /* added 12/9/90 TC */
    newturn=0; /* added 1/20/91 TC */
    hiddenenemy=1;
    binconfirm=1;
    plkills=2;
    sbrank=3;
    tournplayers=5;
    udpAllowed=1;		/* UDP */


    f=fopen(SYSDEF_FILE, "r");
    if (f==NULL) {
	fprintf(stderr, "No system defaults file!\n");
        return;
    }
    stat(SYSDEF_FILE, &oldstat);

    while (fgets(buf, 199, f)!=NULL) {
	s=index(buf, '=');
	if (s==NULL) continue;
	*s='\0';
	s++;
	if (strcmp(buf, "TOURN")==0) {
	    tournplayers=atoi(s);
	    if (tournplayers==0) tournplayers=5;
	} else if (strcmp(buf, "SHIPS")==0) {
	    for (i=0; i<NUM_TYPES; i++) {
		shipsallowed[i]=0;
	    }
	    readstrings("SHIPS", s, shiptypes, shipsallowed, NUM_TYPES);
	} else if (strcmp(buf, "WEAPONS")==0) {
	    for (i=0; i<WP_MAX; i++) {
		weaponsallowed[i]=0;
	    }
	    readstrings("WEAPONS", s, weapontypes, weaponsallowed, WP_MAX);
	} else if (strcmp(buf, "PLKILLS")==0) {
	    plkills=atoi(s);
	} else if (strcmp(buf, "SBRANK")==0) {
	    sbrank=atoi(s);
	} else if (strcmp(buf, "CHAOS")==0) {
	    chaos=atoi(s);
	} else if (strcmp(buf, "TOPGUN")==0) { /* change 12/9/90 TC */
	    topgun=atoi(s);
	} else if (strcmp(buf, "NEWTURN")==0) { /* change 1/20/91 TC */
	    newturn=atoi(s);
	} else if (strcmp(buf, "HIDDEN")==0) {
	    hiddenenemy=atoi(s);
	} else if (strcmp(buf, "MAXLOAD")==0) {
	    maxload=atof(s);
	} else if (strcmp(buf, "PLANETS")==0) {
	    for (i=0; i<MAXPLANETS; i++) {
		startplanets[i]=0;
	    }
	    readstrings("PLANETS", s, planettypes, startplanets, MAXPLANETS);
	} else if (strcmp(buf, "CONFIRM")==0) {
	    binconfirm=atoi(s);
	} else if (strcmp(buf, "UDP")==0) {             /* UDP */
	    udpAllowed=atoi(s);
	} else {
	    fprintf(stderr, "System default %s unknown\n", buf);
	}
    }

    /* Make sure every team can start at some planet! */
    for (i=0; i<4; i++) { 
	for (j=0; j<10; j++) {
	    if (startplanets[i*10+j]) goto foundone;
	}
	fprintf(stderr, "No starting planets specified for team %d\n", i);
	startplanets[i*10]=1;
foundone: ;
    }

    fclose(f);
}

readstrings(type, string, keys, array, max)
char *type;
char *string;
char **keys;
int *array;
int max;
{
    int i;

    while (*string!='\0') { 
	while (*string=='\n' || *string==' ' || *string==',' || *string=='\t') string++;
	if (*string=='\0') break;
	for (i=0; i<max; i++) {
	    if (strncmp(keys[i], string, strlen(keys[i]))==0) {
		string+=strlen(keys[i]);
		array[i]=1;
		break;
	    }
	}
	if (i==max) {
	    fprintf(stderr, "%s type %s unknown!\n", type, string);
	    string++;
	}
    }
}

/* This function will update all of the defaults if the default file 
 * changed.  It is called often, and assuming the OS caches the file
 * inode info well, this isn't a problem.
 */
int
update_sys_defaults()
{
    struct stat newstat;

    if (stat(SYSDEF_FILE, &newstat)==0) {
	if (newstat.st_ino != oldstat.st_ino ||
	    newstat.st_mtime != oldstat.st_mtime) {
	    readsysdefaults();
	    return(1);
	}
    }
    return(0);
}
