#include <stdio.h>
#include <time.h>

#define OVERRIDE "/usr/users/terence/lib/xtrekII/.override"
#define DENY     "/usr/users/terence/lib/xtrekII/.deny"

#define SUN 0
#define MON 1
#define TUE 2
#define WED 3
#define THU 4
#define FRI 5
#define SAT 6

/*
 * returns a 1 if the time is acceptable for play, 0 otherwise
 */
int time_access()
{
    struct tm *tm;
    long secs;
    FILE *fd;

    if ((fd=fopen(OVERRIDE,"r")) != NULL) {
	fclose(fd);
	return 1;
    }

    if ((fd=fopen(DENY, "r")) != NULL) {
	fclose(fd);
	return 0;
    }

    time(&secs);
    tm = localtime(&secs);

    if ((tm->tm_wday == SUN) || (tm->tm_wday == SAT)) { /* Weekends */
	return 1;
    }
    else { /* weekday */
	switch (tm->tm_hour) {
	  case 0:
	  case 1:
	  case 2:
	  case 3:
	  case 4:
	  case 5:
	  case 6:
	  case 7:
	  case 8:
	    return 1;
	    break;
	  case 9:  /* deny access */
	  case 10:
	  case 11:
	  case 12:
	  case 13:
	  case 14:
	  case 15:
	  case 16:
	    return 0;
	    break;
	  case 17:
	  case 18:
	  case 19:
	  case 20:
	  case 21:
	  case 22:
	  case 23:
	  default:
	    return 1;
	    break;
	}
    }
}
