#include <stdio.h>
#include <sys/types.h>
#include <sys/file.h>
#include <pwd.h>
#include "defs.h"
#include "struct.h"
/*char *malloc();*/

char *ranks[] = {
    "Ensigns",
    "Lieutenants",
    "Lieutenant Commanders",
    "Commanders",
    "Captains",
    "Fleet Captains",
    "Commodores",
    "Rear Admirals",
    "Admirals" };

/* There is a time bias towards people with at least 4 hours of play... */
#define TIMEBIAS 4

int daysold = 28;

struct statentry player;
struct status *status;
struct rawdesc *output=NULL;
char mode;
int showall;
struct rawdesc {
    struct rawdesc *next;
    char name[16];
    int ttime;
    int rank;
    float bombing, planets, offense, defense;
    int nbomb, nplan, nkill, ndie;
    int sbkills, sblosses, sbtime;
    float sbmaxkills;
    long lastlogin;
}

addNewPlayer(name, pl, mode)
char *name;
struct player *pl;
char mode;
{
    struct rawdesc *temp;
    struct rawdesc **temp2;

    temp=(struct rawdesc *) malloc(sizeof(struct rawdesc));
/*    puts(name);*/
    strcpy(temp->name, name);
    temp->lastlogin=pl->p_stats.st_lastlogin;
    temp->ttime=pl->p_stats.st_tticks / 10;
    temp->rank=pl->p_stats.st_rank;
    temp->bombing=bombingRating(pl);
    temp->planets=planetRating(pl);
    temp->offense=offenseRating(pl);
    temp->defense=defenseRating(pl);
    temp->nbomb=pl->p_stats.st_tarmsbomb;
    temp->nplan=pl->p_stats.st_tplanets;
    temp->nkill=pl->p_stats.st_tkills;
    temp->ndie=pl->p_stats.st_tlosses;
    temp->sbtime=pl->p_stats.st_sbticks / 10;
    temp->sbkills=pl->p_stats.st_sbkills;
    temp->sblosses=pl->p_stats.st_sblosses;
    temp->sbmaxkills=pl->p_stats.st_sbmaxkills;
    temp2 = &output;
    for (;;) {
	if (((*temp2)==NULL) || ordered(temp, *temp2, mode)) {
	    temp->next=(*temp2);
	    (*temp2) = temp;
	    break;
	}
	temp2= &((*temp2)->next);
    }
}

ordered(num1, num2, mode)
struct rawdesc *num1, *num2;
char mode;
{
    float temp, temp2;

    switch(mode) {
    case 'o':
	temp =num1->ttime*(num1->offense)/(num1->ttime/90 + 40 * TIMEBIAS);
	temp2=num2->ttime*(num2->offense)/(num2->ttime/90 + 40 * TIMEBIAS);

	if (temp >= temp2) {
	    return(1);
	} else {
	    return(0);
	}

    case 'd':
	temp =(float) num1->ttime/(num1->ndie + num1->ttime/90 + 40 * TIMEBIAS);
	temp2=(float) num2->ttime/(num2->ndie + num2->ttime/90 + 40 * TIMEBIAS);

	if (temp >= temp2) {
	    return(1);
	} else {
	    return(0);
	}
    case 'b':
	temp =num1->ttime*(num1->bombing)/(num1->ttime/90 + 40 * TIMEBIAS);
	temp2=num2->ttime*(num2->bombing)/(num2->ttime/90 + 40 * TIMEBIAS);

	if (temp >= temp2) {
	    return(1);
	} else {
	    return(0);
	}
    case 'p':
	temp =num1->ttime*(num1->planets)/(num1->ttime/90 + 40 * TIMEBIAS);
	temp2=num2->ttime*(num2->planets)/(num2->ttime/90 + 40 * TIMEBIAS);

	if (temp >= temp2) {
	    return(1);
	} else {
	    return(0);
	}
    case 't':
	temp =num1->ttime*(num1->planets+num1->bombing+num1->offense)/(num1->ttime/90 + 10 * TIMEBIAS);
	temp2=num2->ttime*(num2->planets+num1->bombing+num1->offense)/(num2->ttime/90 + 10 * TIMEBIAS);

	if (temp >= temp2) {
	    return(1);
	} else {
	    return(0);
	}
    case 'h':
	temp =num1->ttime;
	temp2=num2->ttime;

	if (temp >= temp2) {
	    return(1);
	} else {
	    return(0);
	}
    case 'a':
	if (num1->rank > num2->rank) return(1);
	if (num2->rank > num1->rank) return(0);

	/* 4/2/89  Rank by DI within class.
	 */
    case 'D':
	temp =num1->ttime*(num1->planets+num1->bombing+num1->offense);
	temp2=num2->ttime*(num2->planets+num2->bombing+num2->offense);

	if (temp >= temp2) {
	    return(1);
	} else {
	    return(0);
	}
    case 's':
	/* A starbase is ranked by how many kills he gets per death. 
	 * (roughly).  More accurately, his ratio is his rating, where
	 * his ratio is kills/(deaths + 2 + hours/4).  So, he is auto
	 * credited with 1 death per four hours, and he gets 2 
	 * automatically.  This encourages some amount of cowardise
	 * in a starbase, but not _too_ much.  It seems to make sense
	 * to me ('course, I may be screwed, but that's the way it goes).
	 */
	temp =((float) num1->sbkills)/
	    (num1->sblosses + 2.0 + (float) num1->sbtime/14400);
	temp2=((float) num2->sbkills)/
	    (num2->sblosses + 2.0 + (float) num2->sbtime/14400);

	if (temp >= temp2) {
	    return(1);
	} else {
	    return(0);
	}
    default:
	return(1);
    }
}
	    
main(argc, argv)
int argc;
char **argv;
{
    int fd;
    static struct player j;
    struct rawdesc *temp;
    int i;
    long totalTime=0;

    status=(struct status *) malloc(sizeof(struct status));

    showall=0; output=NULL;
    mode='a';
    if (argc>1){
	mode= *argv[1];

	if (argv[1][1]=='a') {
	    showall=1;
	}
    }

    if (mode=='O') {
	if (argc>2) daysold=atoi(argv[2]);
    }

    fd = open(GLOBAL, O_RDONLY, 0777);
    if (fd < 0) {
	printf("Cannot open the global file!\n");
	exit(0);
    }
    read(fd, (char *) status, sizeof(struct status));
    close(fd);
    fd = open(PLAYERFILE, O_RDONLY, 0777);
    if (fd < 0) {
	perror(PLAYERFILE);
	exit(1);
    }
    switch(mode) {
    case 'O':
    case 'o':
    case 'r':
    case 'b':
    case 'p':
    case 'd':
    case 'a':
    case 't':
	printf("    Name               Hours      Planets     Bombing     Offense     Defense\n");
	printf("    Totals           %7.2f %11d %11d %11d %11d\n",
	    status->time/36000.0, status->planets, status->armsbomb, 
	    status->kills, status->losses, status->timeprod/10);
	break;
    case 'D':
    case 'h':
	printf("    Name               Hours   Ratings   DI    Last login\n");
	break;
    case 's':
	printf("    Name               Hours   Kills   Losses   Ratio  Maxkills\n");
	break;
    case 'T':
	totalTime=status->timeprod/10;
	break;
    default:
	usage();
	break;
    case 'g':
	printf("                                Non-Tournament                               Tournament                        Starbase\n");
	printf("Name             seconds kills losses planets armies maxkills   seconds kills losses planets armies   seconds kills losses maxkills\n");
	break;
    case 'A':
	printf("%10ld %10d %10d %10d %10d %10ld\n",
	    status->time,
	    status->planets,
	    status->armsbomb,
	    status->kills,
	    status->losses, 
	    status->timeprod);
	break;
    }

    i= -1;
    while (read(fd, (char *) &player, sizeof(struct statentry)) == sizeof(struct statentry)) {
	i++;
	j.p_stats = player.stats;
	if (j.p_stats.st_tticks<1) j.p_stats.st_tticks=1;
	if (player.stats.st_tticks<1) player.stats.st_tticks=1;
	fixkeymap(player.stats.st_keymap);
	switch (mode) {
	case 'o':
	case 'b':
	case 'p':
	case 'd':
	case 'a':
	case 't':
	case 'D':
	case 'h':
	    /* Throw away entries with less than 1 hour play time */
	    if (!showall && player.stats.st_tticks < 36000) continue;
	case 's':
	    /* Throw away entries unused for over 4 weeks */
	    if (!showall && time(NULL) > player.stats.st_lastlogin + 2419200) continue;
	    /* Throw away SB's with less than 1 hour play time */
	    if (!showall && mode=='s' && player.stats.st_sbticks < 36000) continue;
	    addNewPlayer(player.name, &(j), mode);
	    break;
	case 'O':
	    if (player.stats.st_lastlogin + daysold*86400 > time(NULL)) break;
	case 'r':
	    printf("%3d %-16.16s %7.2f %6d %5.2f %5d %5.2f %5d %5.2f %5d %5.2f\n",
		i,
		player.name,
		player.stats.st_tticks / 36000.0,
		player.stats.st_tplanets,
		planetRating(&j),
		player.stats.st_tarmsbomb,
		bombingRating(&j),
		player.stats.st_tkills,
		offenseRating(&j),
		player.stats.st_tlosses,
		defenseRating(&j));
	    break;
	case 'T':
	    totalTime += player.stats.st_ticks / 10 +
			 player.stats.st_sbticks / 10;
	    break;
	default:
	case 'g':
	    printf("%-16.16s %7d %5d %6d %7d %6d %8.2f   %7d %5d %6d %7d %6d   %7d %5d %6d %8.2f\n",
		player.name,
		player.stats.st_ticks / 10,
		player.stats.st_kills,
		player.stats.st_losses,
		player.stats.st_planets,
		player.stats.st_armsbomb,
		player.stats.st_maxkills,
		player.stats.st_tticks / 10,
		player.stats.st_tkills,
		player.stats.st_tlosses,
		player.stats.st_tplanets,
		player.stats.st_tarmsbomb,
		player.stats.st_sbticks / 10,
		player.stats.st_sbkills,
		player.stats.st_sblosses,
		player.stats.st_sbmaxkills);
	    break;
	case 'A':
	    strcat(player.name, "_");
	    printf("%-16.16s %-16.16s %-96.96s %1d %9.2lf %7d %7d %7d %7d %7d %7d %7d %7d %7d %7d %7d %7d %7d %9.2lf %9ld %7d\n",
		player.name,
		player.password,
		player.stats.st_keymap,
		player.stats.st_rank,
		player.stats.st_maxkills,
		player.stats.st_kills,
		player.stats.st_losses,
		player.stats.st_armsbomb,
		player.stats.st_planets,
		player.stats.st_ticks,
		player.stats.st_tkills,
		player.stats.st_tlosses,
		player.stats.st_tarmsbomb,
		player.stats.st_tplanets,
		player.stats.st_tticks,
		player.stats.st_sbkills,
		player.stats.st_sblosses,
		player.stats.st_sbticks,
		player.stats.st_sbmaxkills,
		player.stats.st_lastlogin,
		player.stats.st_flags);
	    break;
	}
    }
    close(fd);
    if (mode=='T') {
	printf("Total play time for this game has been at least %ld seconds\n",
	    totalTime);
    }
    if (mode=='o' || mode=='b' || mode=='p' || mode=='d' || mode=='a' || mode=='s' || mode=='D' || mode=='h' || mode=='t') {
	int lastrank= -1;
	temp=output;
	i=0;
	while (temp!=NULL) {
	    if (mode == 'a' && lastrank != temp->rank) {
		lastrank = temp->rank;
		printf("\n%s:\n", ranks[lastrank]);
	    }
	    i++;
	    switch(mode) {
	    case 'o':
	    case 'b':
	    case 'p':
	    case 'd':
	    case 'a':
	    default:
		printf("%3d %-16.16s %7.2f %6d %5.2f %5d %5.2f %5d %5.2f %5d %5.2f\n",
		    i,
		    temp->name,
		    temp->ttime / 3600.0,
		    temp->nplan,
		    temp->planets,
		    temp->nbomb,
		    temp->bombing,
		    temp->nkill,
		    temp->offense,
		    temp->ndie,
		    temp->defense);
		break;
	    case 'D':
	    case 'h':
		printf("%3d %-16.16s %7.2f %7.2f %8.2f  %s",
		    i,
		    temp->name,
		    temp->ttime / 3600.0,
		    temp->bombing+temp->offense+temp->planets,
		    (temp->bombing+temp->offense+temp->planets)*temp->ttime/3600.0,
		    ctime(&(temp->lastlogin)));
		break;
	    case 's':
		printf("%3d %-16.16s %7.2f %7d %8d %7.2f %9.2f\n", 
		    i,
		    temp->name,
		    temp->sbtime / 3600.0,
		    temp->sbkills,
		    temp->sblosses,
		    (temp->sblosses==0) ? (float) temp->sbkills : (float) temp->sbkills/temp->sblosses,
		    temp->sbmaxkills);
		break;
	    }
	    temp=temp->next;
	}
    }
    exit(0);
}

fixkeymap(s)
char *s;
{
    int i;

    for (i=0; i<95; i++) {
	if ((s[i]==0) || (s[i] == 10)) { /* Pig fix (no ^J) 7/8/92 TC */
	    s[i]=i+32;
	}
    }
    s[95]=0;
}

usage()
{
    printf("usage: scores [mode]\n");
    printf("Modes:\n");
    printf("a - print best players in order\n");
    printf("o - list players with best offense\n");
    printf("d - list players with best defense\n");
    printf("p - list players with best planet rating\n");
    printf("b - list players with best bombing rating\n");
    printf("t - list players with best total ratings\n");
    printf("s - list best starbase players\n");
    printf("  Note: for modes [aodpbs], players with less than 1 hour\n");
    printf("    or who haven't played for four weeks are omitted\n");
    printf("r - list all players, hours, and ratings (no order)\n");
    printf("A - list entire database in ascii form (for use with newscores)\n");
    printf("T - print rough number of seconds of play time\n");
    printf("O - print players who haven't logged in for 4 weeks\n");
    printf("D - list players by DI\n");
    printf("h - list players by hours\n");
    printf("none: list all players, and their totals\n");
    exit(0);
}
