#include <stdio.h>
#include <strings.h>
#include <sys/types.h>
#include <sys/time.h>
#include <signal.h>
#include <setjmp.h>
#include <sys/file.h>
#include <math.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <errno.h>
#include <pwd.h>
#include <string.h>
#include <ctype.h>
#include "defs.h"
#include "struct.h"
#include "../ntserv/data.h"

struct player *players;
struct player *me;
struct torp *torps;
struct ship *myship;
struct stats *mystats;
struct planet *planets;
struct phaser *phasers;
struct message *messages;
struct mctl *mctl;
struct team *teams;
struct plasmatorp *plasmatorps;
struct status *status;

#define COS(x) ((x) >= 0.0 ? Cosine[(int)(x)] : Cosine[(int)(-(x))])
#define SIN(x) ((x) >= 0.0 ? Sine[(int)(x)] : -Sine[(int)(-(x))])

#define PUPDATE 0

int pl_home = 0;
int pl_core[40];
int pl_dist[40];
double increment = 0.001;
double incrementrecip = 1000.0;
float *Cosine, *Sine;

double dpre;
double fpre;
double pi = 3.1415926;

main(argc, argv)
int argc;
char **argv;
{
    char buf[80];
    char buf2[80];
    char race = 'F';
    double dx, dy;
    int i;

    int pre;
    double step;

    static struct itimerval udt;

    int pmove();

    pre = 3.5/increment;
    dpre = (double) pre;

    Cosine = (float*) calloc(sizeof(float), pre);
    Sine = (float*) calloc(sizeof(float), pre);
    for (i = 0; i < pre; i++) {
	Cosine[i] = cos((double)i*increment);
	Sine[i] = sin((double)i*increment);
    }

    pl_home = 0; pl_core[0] = 5; pl_core[1] = 7; pl_core[2] = 8; pl_core[3] = 9;
    openmem();
    planets[5].pl_x = 30000; planets[5].pl_y = 90000;
    planets[7].pl_x = 11000; planets[7].pl_y = 75000;
    planets[8].pl_x =  8000; planets[8].pl_y = 93000;
    planets[9].pl_x = 32000; planets[9].pl_y = 74000;
    for (i=1; i<argc; i++) {
	if (argv[i][0]=='-') {
	    switch(argv[i][1]) {
	      case 'i':
		sscanf(&(argv[i][2]), "%f", &increment);
		printf("Increment: %f.\n", increment);
		break;
	      case 'F': pl_home = 0; pl_core[0] = 5; pl_core[1] = 7; pl_core[2] = 8; pl_core[3] = 9; race = argv[i][1]; break;
	      case 'R': pl_home = 10; pl_core[0] = 12; pl_core[1] = 15; pl_core[2] = 16; pl_core[3] = 19; race = argv[i][1]; break;
	      case 'K': pl_home = 20; pl_core[0] = 24; pl_core[1] = 26; pl_core[2] = 29; pl_core[3] = 25; race = argv[i][1]; break;
	      case 'O': pl_home = 30; pl_core[0] = 34; pl_core[1] = 37; pl_core[2] = 38; pl_core[3] = 39; race = argv[i][1]; break;
	    default:
		usage(argv[0]);
		break;
	    }
	  switch (race) {
	    case 'F':  strcpy(buf2, "Federation"); break;
	    case 'R':  strcpy(buf2, "Romulan"); break;
	    case 'K':  strcpy(buf2, "Klingon"); break;
	    case 'O':  strcpy(buf2, "Orion"); break;
	  }
	}
    }

    for (i = 0; i < 40; i++) {
	dx = (double) (planets[i].pl_x - GWIDTH/2);
	dy = (double) (GWIDTH/2 - planets[i].pl_y);
	pl_dist[i] = sqrt(dx * dx + dy * dy);
    }

    signal(SIGALRM, pmove);
    udt.it_interval.tv_sec = 2;
    udt.it_interval.tv_usec = PUPDATE;
    udt.it_value.tv_sec = 2;
    udt.it_value.tv_usec = PUPDATE;
    (void) setitimer(ITIMER_REAL, &udt, (struct itimerval *) 0);

    while (1)
	pause();
}

pmove()
{
    int i;
    double dir;
    double dx, dy;
    
    for (i = 0; i < MAXPLANETS; i++) {
	dir = atan2((double) (planets[i].pl_y - GWIDTH/2),
		    (double) (planets[i].pl_x - GWIDTH/2));
	/*	    if (i%2)
		    dir += increment;
		    else
		    dir -= increment;*/
/*	printf("Atan2 Dir is %f (%d,%d).\n", dir, planets[i].pl_x,
	       planets[i].pl_y);*/
	if (dir > pi) dir = dir - 2.0*pi;
/*	printf("dir = %f, dir*100 = %f, rint() = %f. %f = %d.\n", dir, dir*100.0, rint(dir*100.0), rint(dir*100.0+1.5), (int) (rint(dir*100.0) + 1.0));*/
	if (dir >= 0.0)
	    dir = (dir*incrementrecip+1.5);
	else
	    dir = (dir*incrementrecip+0.5);


	planets[i].pl_x = GWIDTH/2 + (int) (pl_dist[i] * (dx = COS(dir)));
	planets[i].pl_y = GWIDTH/2 + (int) (pl_dist[i] * (dy = SIN(dir)));
	dir = atan2((double) (planets[i].pl_y - GWIDTH/2),
		    (double) (planets[i].pl_x - GWIDTH/2));

	planets[i].pl_flags |= PLREDRAW;
    }
}

usage(string)
char *string;
{
    printf("Usage: %s [-dnnn]\n", string);
    printf("  -dnnn  delay nnn 1/10 seconds between frames\n");
}

pmessage(str, recip, group)
char *str;
int recip;
int group;
{
    struct message *cur;
    if (++(mctl->mc_current) >= MAXMESSAGE)
	mctl->mc_current = 0;
    cur = &messages[mctl->mc_current];
    cur->m_no = mctl->mc_current;
    cur->m_flags = group;
    cur->m_time = 0;
    cur->m_recpt = recip;
    cur->m_from = 255; /* change 3/30/91 TC */
    (void) sprintf(cur->m_data, "%s", str);
    cur->m_flags |= MVALID;
}

openmem()
{
    extern int errno;
    int	shmemKey = PKEY;
    int	shmid;
    struct memory	*sharedMemory;

    errno = 0;
    shmid = shmget(shmemKey, 0, 0);
    if (shmid < 0) {
	if (errno != ENOENT) {
	    fprintf(stderr, "shmget\n");
	    exit(1);
	}
	shmid = shmget(shmemKey, 0, 0);
	if (shmid < 0) {
	    fprintf(stderr, "Daemon not running\n");
	    exit (1);
	}
    }
    sharedMemory = (struct memory *) shmat(shmid, 0, 0);
    if (sharedMemory == (struct memory *) -1) {
	fprintf(stderr, "shared memory\n");
	exit (1);
    }
    players = sharedMemory->players;
    torps = sharedMemory->torps;
    plasmatorps = sharedMemory->plasmatorps;
    planets = sharedMemory->planets;
    phasers = sharedMemory->phasers;
    mctl = sharedMemory->mctl;
    messages = sharedMemory->messages;
    teams = sharedMemory->teams;
    status = sharedMemory->status;
}

