#include <X11/Xlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/time.h>
#include <signal.h>
#include <setjmp.h>
#include <sys/file.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <errno.h>
#include <pwd.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "defs.h"
#include "struct.h"

struct player *players;
struct player *me;
struct torp *torps;
struct ship *myship;
struct stats *mystats;
struct planet *planets;
struct phaser *phasers;
struct message *messages;
struct mctl *mctl;
struct team *teams;

openmem()
{
    extern int errno;
    int	shmemKey = PKEY;
    int	shmid;
    struct memory	*sharedMemory;

    errno = 0;
    shmid = shmget(shmemKey, 0, 0);
    if (shmid < 0) {
	if (errno != ENOENT) {
	    fprintf(stderr, "shmget\n");
	    exit(1);
	}
	shmid = shmget(shmemKey, 0, 0);
	if (shmid < 0) {
	    fprintf(stderr, "Daemon not running\n");
	    exit (1);
	}
    }
    sharedMemory = (struct memory *) shmat(shmid, 0, 0);
    if (sharedMemory == (struct memory *) -1) {
	fprintf(stderr, "shared memory\n");
	exit (1);
    }
    players = sharedMemory->players;
    torps = sharedMemory->torps;
    planets = sharedMemory->planets;
    phasers = sharedMemory->phasers;
    mctl = sharedMemory->mctl;
    messages = sharedMemory->messages;
    teams = sharedMemory->teams;
}

main(argc, argv)
int argc;
char *argv[];
{
    int i; 
    int oldmctl;

    int filter;			/* 7/29/91 TC */

    openmem();

    filter = argc > 1;		/* special logging */

    oldmctl=mctl->mc_current;
    if (!filter)
	for (i=0; i<=oldmctl; i++) {
	    printf("%s\n", messages[i].m_data);
	}
    for (;;) {
	sleep(1);
	while (oldmctl!=mctl->mc_current) {
	    oldmctl++;
	    if (oldmctl==50) oldmctl=0;
	    if (filter)
		log(&(messages[oldmctl]));
	    else {
		printf("%s\n", messages[oldmctl].m_data);
		fflush(stdout);
	    }
	}
    }
}

log(m)
struct message *m;
{
    long curtime;
    struct tm *tmstruct;
    int hour;
    int least = MBOMB;

    /* decide whether or not to log this message */

    if (m->m_flags & MINDIV) return; /* individual message */

    if (!(m->m_flags & MMASK)) return;
    if ((m->m_flags & MMASK) > least) return;

    time(&curtime);
    tmstruct = localtime(&curtime);
    if (!(hour = tmstruct->tm_hour%12)) hour = 12;
    printf("%02d:%02d %-73.73s\n", hour, tmstruct->tm_min,
	   m->m_data);
    fflush(stdout);
}
